/*This is the implementation for the Tab History List class for the Tab Enhancements by Asingh*/


var TabHistoryList = {
	
	mDeleteTabList : null,
	
	Init : function() {
		mDeleteTabList = new Array();
	},
	

	// MERC - Amit: returns an array of the deleted tab URL
	GetDeleteTabList : function() {
		
		return mDeleteTabList;
	},
		
    // MERC - JCH: Focus the URL if already open else add new tab.
	Restore : function(event) {

		var aTab;
		var menuItem = event.target;
		var isOpenTab = menuItem.getAttribute("opentab");
		var tabbrowser = getBrowser();

		// Check the deleted list first when restoring a tab.
		for (var i=mDeleteTabList.length-1; i>-1; i--) {
			if (mDeleteTabList[i]==menuItem.label) {
				mDeleteTabList.splice(i,1);
				tabbrowser.selectedTab = getBrowser().addTab(menuItem.label);
				return;
			}
		}
		
		// If not in the deleted list, then check open tabs.
		const browsers = tabbrowser.mPanelContainer.childNodes;
		for (var i = 0; i < browsers.length; ++i) {
			browser = tabbrowser.getBrowserAtIndex(i);
			url = browser.currentURI.spec;
			if (menuItem.label==url) {
				tabbrowser.selectedTab = tabbrowser.mTabContainer.childNodes[i];
				return;
			}
		}

/*		if (isOpenTab=="true") {
			const browsers = tabbrowser.mPanelContainer.childNodes;
			for (var i = 0; i < browsers.length; ++i) {
			   browser = tabbrowser.getBrowserAtIndex(i);
			   url = browser.currentURI.spec;
			   if (menuItem.label==url) {
				   tabbrowser.selectedTab = tabbrowser.mTabContainer.childNodes[i];
				   break;
			   }
			}
		} else {
    		var aTab = getBrowser().addTab(menuItem.label);
			tabbrowser.selectedTab = aTab;
		}
*/
	},	
		
	// MERC - Amit: Deletes a URL from mDeleteTabList	
	RemoveDeleteListURL: function(url) {
		for(var i=0; i<mDeleteTabList.length; i++) {
			if(mDeleteTabList[i]==url) {
				mDeleteTabList.splice(i,1);
			}
		}
	},
			
	// MERC - Amit: returns the array index of a specified url from mDeleteTablist
	FindDeleteIndexOfURL: function(url) {
  		var i;
		var matchedI =-1;
		for(i=0;i<mDeleteTabList.length;i++) {
			if(mDeleteTabList[i]==url) {
				matchedI = i;
				break;
			}
		}
		return matchedI;
	},
 

 	// MERC - Amit: Removes all null elements in mDeleteTabList 
 	CleanDeleteList : function() {
 		for(var i=0;i<mDeleteTabList.length;i++) {
 			if(mDeleteTabList[i]==null) {
 				 delete[i]; 			
 			}
 		}
	},

 	
 	// MERC - Amit: returns true if mOpenTabList contains a specified url
 	OpenListHasURL: function(url) {
 		for(i=0;i<mOpenTabList.length;i++) {
			if(mOpenTabList[i]==url) {
	 			return true;
    		}
  		}	
		return false;
	},

    // MERC - Amit: returns true if mDeleteTabList contains a specified url
    DeleteListHasURL: function(url) {
		//if (!mDeleteTabList)
		//	return;
		for (var i=0; i<mDeleteTabList.length; i++) {
			if(mDeleteTabList[i]==url) {
	 			return true;
	 		}
		} 
		
		return false; 
	},

	// MERC - JCH: Determine if URL is in given array.
	EntryExists: function(arr, url) {
		for (i=0; i<arr.length; i++) {
			if (arr[i]==url) {
	 			return true;
	 		}
		} 
		return false;
	}, 		


	// MERC - JCH: When a tab is closed, add its URL to deleted list.
	AddURLToDeleteList: function(url) {

		// If URL is also in an open tab, don't add to delete list.

	//	var browser;
	//	var count = 0;
	//	const browsers = getBrowser().mPanelContainer.childNodes;
	//	for (var i = 0; i < browsers.length; ++i) {
	//	   browser = getBrowser().getBrowserAtIndex(i);
	//	   if (url == browser.currentURI.spec) {
	//	       count++;
	//	   }
	//	   if (count>1)
	//	       return;
	//	}

	//	if (!this.EntryExists(mDeleteTabList,url)) {
	//		var size = mDeleteTabList.push(url);
	//	}

		mDeleteTabList.push(url);

	},


	// MERC - JCH: Restore a tab from the delete list when user selects undo menu item
	// or Ctrl-Z.
	RestoreLastDeletedTab: function() {

		if (mDeleteTabList.length > 0) {
			var url = mDeleteTabList.pop();
			var tabbrowser = getBrowser();
		    var aTab = tabbrowser.addTab(url);
			tabbrowser.selectedTab = aTab;
		}
	},

	// MERC - JCH: Add the open and deleted URLs to the popup menu 
	// such that there are no duplicate entries.
	ShowTabHistoryMenu: function() {

		// Get popup menu element.
		var popup = document.getElementById('tabHistoryMenu');
		var separatorObj = popup.firstChild;

		// Populate this array with items added to popup menu.
		// Check it before adding item and don't add item if it's already there.
		var mergedList = new Array();

		// First, uniquely add all the open URLs to the menu.
		var url;
		var browser;
		var tabbrowser = getBrowser();
		const browsers = tabbrowser.mPanelContainer.childNodes;
		for (var i = 0; i < browsers.length; ++i) {
		   browser = tabbrowser.getBrowserAtIndex(i);
           url = browser.currentURI.spec;
//		   if (!this.EntryExists(mergedList, url)) {
		       mergedList.push(url);
			   var historyItem = document.createElement('menuitem');
			   historyItem.setAttribute('label', url);

			   // Add attribute to open tabs.
			   historyItem.setAttribute('opentab', 'true');

			   historyItem.setAttribute("oncommand", "TabHistoryList.Restore(event)");     
			   popup.insertBefore(historyItem,separatorObj);
//		   }
	    }

		// Now uniquely add the deleted tab URLs to the menu.
		for (i = 0; i < mDeleteTabList.length; ++i) {
		   url = mDeleteTabList[i];
//		   if (!this.EntryExists(mergedList, url)) {
		       mergedList.push(url);
			   var historyItem = document.createElement('menuitem');
			   historyItem.setAttribute('label', url);
			   historyItem.setAttribute("oncommand", "TabHistoryList.Restore(event)");     
			   popup.insertBefore(historyItem,separatorObj);
//		   }
		}

		return true;
	},
	

	// MERC - JCH: When the popup menu closes, remove all its items.
	RemoveChildren: function(aParent) {

		if (!aParent.hasChildNodes())
			return;

		var children = aParent.childNodes;
		for (var i=0; i<children.length; i++) {
			if (children[i].localName == "menuseparator")
				return; 
			aParent.removeChild(children[i]);
		}
	},

	UpdateUndoButton: function() {
		var undoButton = document.getElementById('undoTabClose');
		undoButton.setAttribute("disabled", mDeleteTabList.length < 1?"true":"false");
	},

	ShowArrayValues: function() {
		if (mDeleteTabList==undefined  || mDeleteTabList==null)
			return;
		for (var i=0; i<mDeleteTabList.length; i++) {
			dump("@@@@@@@@@@@@ Array item["+i+"] = "+mDeleteTabList[i]+"  @@@@@@@@@@@@@@@@@@@\n");
		}
	},

			
}