var picSelector;	
if (!picSelector) {
picSelector = {
	mDEBUG : false,
	mTargetProfile: null,
	mTargetProfileDir: null,
	mDirectoryService:null,
	mDisplayContainer:null,
	mPictureSelector:null,
	
	debug : function(msg) {
		if (picSelector.mDEBUG) dump("\t ^^^ pref-shared.js: " + msg + "\n");
	},
		
	init : function() {
		picSelector.mTargetProfile = window.arguments[0];
		picSelector.mDisplayContainer = document.getElementById('boxProfilePictures');
		picSelector.mPictureSelector = document.getElementById('selectorView');
		picSelector.mDirectoryService = Components.classes["@mozilla.org/file/directory_service;1"]
		                                 .getService(Components.interfaces.nsIProperties);
		                                 
		picSelector.mTargetProfileDir = picSelector.mDirectoryService.get("ProfD", Components.interfaces.nsIFile)
		picSelector.mPictureSelector.addEventListener("richview-select",picSelector.doLayout, false); //picSelector.doLayout		
		picSelector.refreshImageSelector();	
		document.title = 'Change picture for ' + picSelector.mTargetProfile.displayName;								
		picSelector.doLayout();
	},
	
	doOK : function() {	
		picSelector.debug('doOK()');								
		if (picSelector.isProceeedOkay()){							
				 picSelector.mTargetProfile.picPath = picSelector.mPictureSelector.selected.getAttribute('src');			
				 window.close();			 				 
		}		
	},
	
	doLayout : function(){
		picSelector.debug('doLayout()');						
		document.getElementById('btnOK').disabled = !picSelector.isProceeedOkay();
	},
	
	isProceeedOkay : function (){		
		if (picSelector.mPictureSelector.selected && 
				picSelector.mPictureSelector.selected.localName == 'profilePicture'){					
			picSelector.debug('isProceeedOkay() = true');					
			return true; 
		} else {
			picSelector.debug('isProceeedOkay() = false');					
			return false;
		}				
	},
		
	doCancel : function() {
		picSelector.debug('doCancel()');
		window.close();
	},
	
	getPictureRows : function (){
		
		return document.getElementsByAttribute('pictureRow', 'true');	
		
	},
	
	createPictureRow: function (){
		
		var row = document.createElement("hbox");
		row.setAttribute("pictureRow","true");
		row.setAttribute("flex","1");
		row.setAttribute("style", "-moz-user-focus: ignore;");
		return row;
		
	},
			
	addPictureToEnd: function(path) {
		
		var rows = picSelector.getPictureRows();			
		if (rows.length > 0){		
			
			var lastRowIndex = Math.abs(rows.length - 1);
					
			// If the last row has 6 items then create another					
			if (rows[lastRowIndex].childNodes.length == 6){
				var row = picSelector.createPictureRow();
				picSelector.mDisplayContainer.appendChild(row);				
			} else {
				var row = rows[lastRowIndex];
			}								
		}			
				
		var picture = document.createElement("profilePicture");	
		picture.setAttribute("src", "file:///"+ path);
		picture.setAttribute("class", "viewListItem");
		picSelector.mPictureSelector.selected = picture; 		
		row.appendChild(picture);		
	
	},
	
	refreshImageSelector : function() {
				  				
		var defaultsDir = picSelector.mDirectoryService.get("DefRt", Components.interfaces.nsIFile);				
				
		// Get all the images from the profile defaults
		var defaultFiles = getImageList(defaultsDir.path+"\\DefaultPictures");				
		var profileFiles = getImageList(picSelector.mTargetProfileDir.path+"\\DefaultPictures");
		
		var allFiles = new Array()
		if (profileFiles) allFiles = allFiles.concat(profileFiles);		
		if (defaultFiles) allFiles = allFiles.concat(defaultFiles);		
										
		for(var i = 0; i < allFiles.length; i++){			
			if ((i - Math.floor(i / 6) * 6) == 0){ // Mod
				var row = picSelector.createPictureRow();
				picSelector.mDisplayContainer.appendChild(row);
			}
			
			var picture = document.createElement("profilePicture");	
			picture.setAttribute("src", "file:///"+ allFiles[i]);
			picture.setAttribute("class", "viewListItem");	
			if (i == 0) {picSelector.mPictureSelector.selected = picture;} // set the default selected item
			row.appendChild(picture);
			 			
		}					
	},	
			
	openFilePicker : function() {
		
		var picFile = OpenPictureFilePicker(); // returns a file path
	
		if(picFile.length > 0)	{
			var filePath = picSelector.copyFile(picFile,(picSelector.mTargetProfile.rootDir.path +"\\DefaultPictures"));		
			picSelector.addPictureToEnd(filePath);
		}	
	},
	
	copyFile : function(sourcePath,targetDirPath) {			
		var sourceFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);				
		sourceFile.initWithPath(sourcePath);		
						
		var targetDir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);										
		targetDir.initWithPath(targetDirPath);
		
		var newName = new Date().valueOf() + sourceFile.leafName;
		
		sourceFile.copyTo(targetDir, newName);
		return(targetDir.path + "\\" +newName);
	}

};

}
