var scSiteSettingsPopup = {
		DEBUG : false,
		mSiteName : null,
		mAddSiteButton : null,
		mSitecontrols : null,				
		mSite : null,
		mSecurityLevel: null,
		mSecurityLevelList: null,
		
		debug : function(msg) {
			if (this.DEBUG) dump("\t ^^^ pref-site-settings-util.js: " + msg + "\n");
		},
			
		init : function() {
			this.debug('init()');			
									
															
			/*===================================================
				Pull in arguments passed via the window
			===================================================*/		
			this.mSitecontrols = window.arguments[0];	
			this.mSite = window.arguments[1];	 					
						
			/*===================================================
				The site was passed in so we are going to 
				remove a site from the controlled sites list
			===================================================*/		
			if (this.mSite) {
				this.debug('setting up remove site dialog');
				document.getElementById('box-remove-site-settings').hidden = false;						
				document.getElementById('box-add-site-settings').hidden = true;							
				this.mSecurityLevel = this.mSitecontrols.SCSVC.readSiteControlResource(this.mSite, 'securityLevel');						
				this.debug('security level of site is: ' + this.mSecurityLevel);
				
				if (this.mSecurityLevel == 'Custom') {
					this.debug('setting up remove site dialog - remove custom site settings');
					window.title = document.getElementById('windowTitleRemoveCustomSiteSettings').value;
					document.getElementById('box-remove-custom-site-settings').hidden = false;							
					document.getElementById('box-remove-trust-settings').hidden = true;					
				}else {
					this.debug('setting up remove site dialog - remove trust settings');
					window.title = document.getElementById('windowTitleRemoveTrustSetting').value;
					document.getElementById('box-remove-trust-settings').hidden = false;	
					document.getElementById('box-remove-custom-site-settings').hidden = true;							
				}
				document.getElementById('btn-remove-site').focus();
																					
			} else {					
			/*===================================================
				Site not passed in to we are going to add a site
				to the controlled sites list
			===================================================*/					
				this.debug('setting up add site dialog');
				window.title = document.getElementById('windowTitleAddSiteSettings').value;
				document.getElementById('box-add-site-settings').hidden = false;	
				document.getElementById('box-remove-site-settings').hidden = true;																
				this.mSiteName = document.getElementById('txt-domain');			
				this.mSiteName.focus();
				this.mSiteName.addEventListener("DOMAttrModified", this.doEnabling, false);
				this.mSiteName.validate();
				this.mSecurityLevelList = document.getElementById('lst-security-level');		
				this.mAddSiteButton = document.getElementById('btn-add-site');
				this.mSecurityLevelList.setAttribute("securityLevel", "medium");
			}
			
						
		},
		
		handleEnterKey : function(evt) {	
		            			
			if (evt.keyCode == evt.DOM_VK_RETURN){
				if (this.mSite){
					this.removeSite();
				} else {
					if (document.getElementById('txt-domain').isValid){
        		this.addSite();              
          }
        }
			}
		},            

		addSite : function() {	
			this.debug('addSite()');
			this.mSite = this.mSitecontrols.ensureExplicitSiteControl(this.mSiteName.value);		
			this.debug('adding site: ' + this.mSiteName.value);
			this.debug('secuirty level: ' + this.mSecurityLevelList.value);	
			this.mSitecontrols.setSecurityLevel(this.mSite, this.mSecurityLevelList.value, false);				 
			self.opener.document.getElementById('siteList').refreshList()
			self.opener.document.getElementById('siteList').currentResource = this.mSite;								
			window.close();
		},
		
		removeSite : function() {	
			
			this.debug('removeSite()');	
			
			this.mSitecontrols.removeSite(this.mSite);

			/*===================================================
				Update the notify pref
			===================================================*/								
			var prefServ = Components.classes["@mozilla.org/preferences-service;1"]
	                         .getService(Components.interfaces.nsIPrefBranch);	                         			    			
	    var notify = !document.getElementById('cb-notify').checked;
	    this.debug('notification status for removing controlled sites: ' + notify);
			prefServ.setBoolPref('browser.sitecontrols.notify.remove_controlled_site',notify);	
			
			/*===================================================
				Refrsh the the controlled sites list on the parent 
				and close this window
			===================================================*/														
			self.opener.document.getElementById('siteList').refreshList();
			window.close();												
		},
		
		isValidData :function(){
			
			this.debug('isValidData()');				
						
			if (prefSharedUtils.isWhitespace(this.mSiteName.value)){
				this.debug('isValidData() - failed - white space entry');
				return false;
			} 								
			
			if (this.mSiteName.value.indexOf(".") == - 1) {
				this.debug('isValidData() url failed - no root domains');
				return false;	
			}				 
					
			if (prefSharedUtils.isValidURL(this.mSiteName.value)){				
					this.debug('isValidData() - passed');
					return true;
			} else {
					this.debug('isValidData() url failed - bad url');
					return false;
			}						
		},
		
		doEnabling : function(evt) {			  	    															
		  document.getElementById('btn-add-site').disabled = !evt.target.isValid;
		},
		
		cancel : function() {
			this.debug('cancel()');				
			window.close();
		},
		
		setSecurityLevelImage : function(obj) {
			var listObj = document.getElementById("lst-security-level");
			var level = obj.getAttribute("value");
			switch (level) {
				case "low":
					listObj.setAttribute("securityLevel", "low");
					break;
				case "medium":
					listObj.setAttribute("securityLevel", "medium");
					break;
				case "high":
					listObj.setAttribute("securityLevel", "high");
					break;
			}
		}
	};

	