var pcSiteSettingsPopup;	
if (!pcSiteSettingsPopup) {
pcSiteSettingsPopup = {
			DEBUG : false,
			mSite : null,
			mAddSiteButton : null,												
			mDeckMain: null,
			mOperation: null,
			mBundleMain: null,
			mTargetProfile: null,
			mPrefService: null,
			mDeckConflictWarnings: null,
			mProfileManager:null,	
			mIsShowingProviderLists: false,		
			
			debug : function(msg) {
				if (this.DEBUG) dump("\t ^^^ pref-parental-ctrls-add-remove-site-settings.js: " + msg + "\n");
			},
			
			init : function() {
				this.debug('init()');			
									
				this.mBundleMain = document.getElementById("bundle_PrefProfile");  					
				this.mProviderList = document.getElementById("lstProviderList");  	
				this.mOptionSelected = document.getElementById("grpSelectionOption");  	
				this.mDeckConflictWarnings = document.getElementById("deckConflictWarnings");  					
				this.mPrefService = Components.classes["@mozilla.org/preferences-service;1"]
			                         .getService(Components.interfaces.nsIPrefBranch);																	                              
			                         
				/*===================================================
					Pull in arguments passed via the window
				===================================================*/		
				this.mTargetProfile = window.arguments[0];					
				this.debug('Target profile = ' + this.mTargetProfile.name);																	
				// GLOBAL or PROFILE
				this.mScope = window.arguments[1];		
				this.debug('SCOPE = ' + this.mScope);					
				// ALLOW or BLOCK
				this.mListType = window.arguments[2];					
				this.debug('OPERATION = ' + this.mListType);					
				this.mProfileManager =  window.arguments[3];
				this.mDeckMain = document.getElementById('deckMain');						
				this.mDeckMain = document.getElementById('deckMain');						
																														
				this.populateProviderList();	
				
				// If there are no provider lists then show the section 
				// that allows for just a site entry.				
				// The menupopup property of the menulist is null when there are no items
				if (this.mProviderList.menupopup){ 
					this.mIsShowingProviderLists  = true; 
					this.mSite = document.getElementById('txtSite');	 	
				} else {					
					this.mIsShowingProviderLists  = false; 
					this.mSite = document.getElementById('txtSite2');	 	
				}
				this.mSite.focus();	
				
				this.doLayout();	
				this.showSelectorFields();					
				
			},
			
			populateProviderList: function(){
				this.debug('populateProviderList() - ' + this.mListType);		
				var ds = this.mTargetProfile.getParentalControlLists();					
				var datasources = this.mProviderList.database.GetDataSources();
		    while (datasources.hasMoreElements()){       
		      this.mProviderList.database.RemoveDataSource(datasources.getNext());
		    }    
		    		    
		    this.mProviderList.database.AddDataSource(ds);
		    if (this.mListType == 'ALLOW') {
		    	this.mProviderList.ref = 'http://home.netscape.com/PC-rdf/ProviderAllowLists';
		    } else {
		    	this.mProviderList.ref = 'http://home.netscape.com/PC-rdf/ProviderBlockLists';
		    }
				this.mProviderList.builder.rebuild();												
				this.mProviderList.selectedIndex = 0;
				
			},
			
			selectedOption :function(){
							
				if (this.mOptionSelected.selectedItem) {
					return this.mOptionSelected.selectedItem.value;
				} else {
					return null;					
				}								
			},
			
			selectedProvider :function(){
								
				if (this.mProviderList.selectedItem){
					return this.mProviderList.selectedItem.value
				} else {
					return null;
				}
			},
						
			isValidData :function(){
				
				this.debug('isValidData() - option selected - ' + this.selectedOption());				
				
				if (this.selectedOption() == 'SPECIFIC') {					
					if (prefSharedUtils.isWhitespace(this.mSite.value)){
						this.debug('isValidData() - failed - white space entry');
						return false;
					} 
					
					if (this.mSite.value.indexOf(".") == - 1) {
						this.debug('isValidData() url failed - no root domains');
						return false;	
					}				 
					
					if (prefSharedUtils.isValidURL(this.mSite.value)){				
							this.debug('isValidData() - passed');
							return true;
					} else {
							this.debug('isValidData() url failed - bad url');
							return false;
					}
					
				} else if (this.selectedOption() == 'LIST' && this.selectedProvider()) {
					this.debug('isValidData() - passed');				
					return true;
				} else {
					this.debug('isValidData() - invalid data');				
					return false;
				}
			},			
	
			showConflictWarning: function() {	
				this.mDeckMain.selectedIndex = 1;							
			},						
			
			showSelectorFields: function() {	
				this.mDeckMain.selectedIndex = 0;							
			},						
			
			isShowingConflict: function(){
				return this.mDeckMain.selectedIndex == 1;
			}, 
			
			doLayout: function() {	
				this.debug('doLayout() for ' + this.mListType);						
				if (this.mIsShowingProviderLists){
					document.getElementById("boxShowingLists").hidden = false;					
				} else {
					document.getElementById("boxSuppressingLists").hidden = false;					
				}
																			
				if (this.mListType == 'ALLOW'){
					document.getElementById("lblOptSpecific").value = this.mBundleMain.getString("allowSpecificSiteRadio");
					document.getElementById("lblOptSpecific2").value = this.mBundleMain.getString("allowSpecificSiteRadio");
					document.getElementById("lblOptList").value = this.mBundleMain.getString("allowListOfSitesRadio");		
					if(this.mScope == 'GLOBAL')
					{
						this.mDeckConflictWarnings.selectedIndex = 1;
					}
					else
					{
						this.mDeckConflictWarnings.selectedIndex = 0;
					}
					document.getElementById("btnProceed").label = this.mBundleMain.getString("btnAllow");		
					document.getElementById("btnWarningProceed").label = this.mBundleMain.getString("btnAllow");																														
					if (this.isShowingConflict()&& this.mScope == 'PROFILE'){												
						document.title = this.mBundleMain.getFormattedString("allowConflictWindowTitle", [this.mTargetProfile.profile.displayName]);						
					} else {
						document.title = this.mBundleMain.getString("allowWindowTitle");
					}
					
					
				} else {
					
					document.getElementById("lblOptSpecific").value = this.mBundleMain.getString("blockSpecificSiteRadio");
					document.getElementById("lblOptSpecific2").value = this.mBundleMain.getString("blockSpecificSiteRadio");
					document.getElementById("lblOptList").value = this.mBundleMain.getString("blockListOfSitesRadio");										
					if(this.mScope == 'GLOBAL')
					{
						this.mDeckConflictWarnings.selectedIndex = 3;
					}
					else
					{
						this.mDeckConflictWarnings.selectedIndex = 2;
					}			
					document.getElementById("btnProceed").label = this.mBundleMain.getString("btnBlock");		
					document.getElementById("btnWarningProceed").label = this.mBundleMain.getString("btnBlock");									
					if (this.isShowingConflict()&& this.mScope == 'PROFILE'){						
						document.title = this.mBundleMain.getFormattedString("blockConflictWindowTitle", [this.mTargetProfile.profile.displayName]);						
					} else {
						document.title = this.mBundleMain.getString("blockWindowTitle");
					}					
				} 																				
			},
			
			handleEnterKey : function(evt) {	
			            			
				if (evt.keyCode == evt.DOM_VK_RETURN){
					if (this.mSite.isValid) proceed();
				}
			},            
	
			proceed : function() {	
				
				// If the button pressed is the one on the conflict 
				// window then continue otherwise check for conflict warnings
				// before continueing
				if (this.isShowingConflict()) {
					if(true == this.processRequest())
					{					
							this.saveNotifyPref();
							window.close();
					}
					this.debug('proceed() - end');																			
				} else {
						if (this.isCanActOnSite()) {
							if(true == this.processRequest())
								{					
									window.close();
								}																		
						} else {

							this.showConflictWarning();	
							this.doLayout();		
						}	
				}												
			},
			
			saveNotifyPref: function () {
														
			    var notify = !document.getElementById('cb-notify').checked;			    
					this.mPrefService.setBoolPref('parentalCtrl.notify.add_or_block_site',notify);	
				
			},
			
			
			
			processRequest : function () {
								
				this.debug('proceed() - start');					
					
					if (this.selectedOption() == 'SPECIFIC'){	
						try {	
							
							if (this.mScope == 'GLOBAL') {							
								this.debug('Adding site to global list: ' + prefSharedUtils.getHostFromURL(this.mSite.value));
								this.mTargetProfile.removeSiteFromGlobal(prefSharedUtils.getHostFromURL(this.mSite.value), this.mListType != 'ALLOW')		
								this.mTargetProfile.addSiteToGlobal(prefSharedUtils.getHostFromURL(this.mSite.value), this.mListType == 'ALLOW')								
							} else {							
								this.debug('Adding site to profile list: ' + prefSharedUtils.getHostFromURL(this.mSite.value));		
								this.mTargetProfile.removeSiteFromProfile(prefSharedUtils.getHostFromURL(this.mSite.value), this.mListType != 'ALLOW') 										
								this.mTargetProfile.addSiteToProfile(prefSharedUtils.getHostFromURL(this.mSite.value), this.mListType == 'ALLOW')																												
							}
							
						} catch(e){
							
							var gPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
							gPromptService.alert(window, "Parental Controls", "Unable to add site. Please check site url.");
							return false;
						}	
								
					} else {

						try {
							
							if (this.mScope == 'GLOBAL') {
								var providerID = this.selectedProvider();
								this.debug('Adding provider list to global list: ' + this.selectedProvider());									
								this.mTargetProfile.addListToGlobal(providerID, this.mListType == 'ALLOW')															
							} else {							
								var providerID = this.selectedProvider();
								this.debug('Adding provider list to profile list: ' + providerID);									
								this.mTargetProfile.addListToProfile(providerID, this.mListType == 'ALLOW')																					
							}		
							
						} catch(e){							
							var gPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
							gPromptService.alert(window, "Parental Controls", "Unable to add list.");
							return false;
						}											
					}
																																	
				return true;															
			},
						 
			isCanActOnSite: function (){
				this.debug('isCanActOnSite()');					
	 			var notify = this.mPrefService.getBoolPref('parentalCtrl.notify.add_or_block_site');	 			
	 			var result = true;
	 			if (notify) {				
					if (this.selectedOption() == 'SPECIFIC'){			
													
							result = this.mTargetProfile.canActOnSite(this.mSite.value, true, this.mScope == 'GLOBAL', this.mListType == 'ALLOW');
					} else {																
							result = this.mTargetProfile.canActOnList(this.selectedProvider(), true, this.mScope == 'GLOBAL', this.mListType == 'ALLOW')													
					}																						
				}	 	
				this.debug('isCanActOnSite() =' + result);
				
				return result;		 															
			},
							
			handleKeys : function(evt) {			  	    
				this.debug('handleKeys()');	
				if (evt.keyCode == evt.DOM_VK_RETURN && pcSiteSettingsPopup.isValidData()){
					this.proceed();
				}	else {
					if (pcSiteSettingsPopup.isValidData()){
						document.getElementById('btnProceed').disabled = false;				
					} else {
						document.getElementById('btnProceed').disabled = true;				
					}										
				}
			},
			
			cancel : function() {
				this.debug('cancel()');				
				window.close();
			}
		};
		
		
}

	