	var prefSharedUtils = {
	
	DEBUG : true,
	
		debug : function(msg) {
		if (this.DEBUG) dump("\t ^^^ pref-shared.js: " + msg + "\n");
	},
	
	// This function extracts the domain portion of a URL from
	// a given raw url. If the url is not valid then it returns 
	// null
	 getHostFromURL : function (rawUrl) {
		
		// nsIURI requires a schema so check to see
		// if one has been added. if it doesn't contain one 
		// add http
		if ((rawUrl.indexOf("http")== -1) &&
			 				(rawUrl.indexOf("https")== -1) &&
			 				(rawUrl.indexOf("ftp")== -1) &&
			 				(rawUrl.indexOf("file")== -1)){					 					
			rawUrl = "http://" + rawUrl;				 					
		}
		
		const IOS = Components.classes["@mozilla.org/network/io-service;1"]
          .getService(Components.interfaces.nsIIOService);
					
		var testURI = IOS.newURI(rawUrl, null, null);
		
		// if this is a valid url then host will resolve
		// otherwise return null
		if (testURI.host){				
			return testURI.host;				
		} else {
			return null;
		}
	},
	
	isValidURL: function(url){
														
    url = this.getHostFromURL(url);
							
		if (url){
			this.debug('isValidURL() url passed');
			return true;
		} else {
			this.debug('isValidURL() url failed');
			return false;
		}						
	},
	
	isEmpty :function (s){   
		return ((s == null) || (s.length == 0))
	},
				
	isWhitespace : function(string){
		if (this.isEmpty(string)){
			return true;
		} else {
			//merc - TO
			//BLT 211749
			//Fixed the test to search for non-whitespace and
			//return the negated evaluation.
			return !(/\S/.test(string));
		}
	}
	
};