var _elementIDs = ["autoInstallUpdates","autoDownloadInstallUpdatesToExtension"];

var gObserver;

function onOK() 
{
}

function Startup() 
{
	gObserver = new browserUpdateObserver();
	gObserver.register();

  gObserver.browserStatusUpdate();

	dump('Browser Update Startup()\n');
}

function Shutdown()
{
	gObserver.unregister();

	dump('Browser Update Shutdown()\n');
}

function checkForUpdates()
{
  var updates = Components.classes["@mozilla.org/updates/update-service;1"]
                          .getService(Components.interfaces.nsIUpdateService);
  updates.checkForUpdates([], 0, Components.interfaces.nsIUpdateItem.TYPE_ANY, 
                          Components.interfaces.nsIUpdateService.SOURCE_EVENT_USER,
                          window);
}

// desclare object
function browserUpdateObserver(){
var gUpdateBundle = 0;
var gPrefService = 0;
}

// set prototype for the observer object
browserUpdateObserver.prototype = {
  observe: function(subject, topic, data) {
		// case table for observer topics
    switch(topic) {
			case "nsPref:changed" :
				// reset the critical warning if the update was performed
				if (data == "app.update.performed" || data == "app.update.updatesAvailable")
					this.browserStatusUpdate();
			break;
	    case "Update:Extension:Started":
	    {
			  var browserUpdateButton = document.getElementById('browserUpdateButton');
			  browserUpdateButton.disabled = true;
			  var browserUpdateStatus = document.getElementById('browserUpdateStatus');
				browserUpdateStatus.value = gUpdateBundle.getString('extensionUpdating');
			}
	    break;
	    case "Update:Extension:Ended":
	    {
			  var browserUpdateButton = document.getElementById('browserUpdateButton');
			  browserUpdateButton.disabled = false;
				this.browserStatusUpdate();
			}
	    break;
	  }
	},
  
  register: function() {
		gUpdateBundle = document.getElementById('bundle_update');
		gPrefService = Components.classes["@mozilla.org/preferences-service;1"]
		                         .getService(Components.interfaces.nsIPrefService);
    gPrefService = gPrefService.getBranch(null).QueryInterface(Components.interfaces.nsIPrefBranchInternal);

    // starting observer service for security dashboard ..
    
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this, "Update:Extension:Started", false);
    observerService.addObserver(this, "Update:Extension:Ended", false);
	  
	  gPrefService.addObserver("app.update.performed", this, false);
	  gPrefService.addObserver("app.update.updatesAvailable", this, false);
  },
  
  unregister: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                            .getService(Components.interfaces.nsIObserverService);
    observerService.removeObserver(this, "Update:Extension:Started", false);
    observerService.removeObserver(this, "Update:Extension:Ended", false);
	  
	  gPrefService.removeObserver("app.update.performed", this);
	  gPrefService.removeObserver("app.update.updatesAvailable", this);
  },
  
  browserStatusUpdate: function()	{
		try {
		  // set update description
		  var browserUpdateDesc = document.getElementById('browserUpdateDesc');
		 	var autoInstallUpdates = document.getElementById('autoInstallUpdates').selectedIndex;
		 	var autoDownloadInstallUpdatesToExtension = document.getElementById('autoDownloadInstallUpdatesToExtension').selectedIndex;
		  
		  if(autoInstallUpdates == autoDownloadInstallUpdatesToExtension) {
			  switch(autoInstallUpdates) {
			  	case 0:
			  		browserUpdateDesc.textContent = gUpdateBundle.getString('askBoth');
			  		break;
			  	case 1:
			  		browserUpdateDesc.textContent = gUpdateBundle.getString('downloadAskInstallBoth');
			  		break;
			  	case 2:
			  		browserUpdateDesc.textContent = gUpdateBundle.getString('downloadInstallBoth');
			  		break;
			  	default:
						dump("\nBrowser Update: New browser update style");
			  }
			}
			else {
			  switch(autoInstallUpdates) {
			  	case 0:
			  		browserUpdateDesc.textContent = gUpdateBundle.getString('askBrowser');
			  		break;
			  	case 1:
			  		browserUpdateDesc.textContent = gUpdateBundle.getString('downloadAskInstallBrowser');
			  		break;
			  	case 2:
			  		browserUpdateDesc.textContent = gUpdateBundle.getString('downloadInstallBrowser');
			  		break;
			  	default:
						dump("\nBrowser Update: New browser update style");
			  }
		
			  switch(autoDownloadInstallUpdatesToExtension) {
			  	case 0:
			  		browserUpdateDesc.textContent += " " + gUpdateBundle.getString('askExtensions');
			  		break;
			  	case 1:
			  		browserUpdateDesc.textContent += " " + gUpdateBundle.getString('downloadAskInstallExtensions');
			  		break;
			  	case 2:
			  		browserUpdateDesc.textContent += " " + gUpdateBundle.getString('downloadInstallExtensions');
			  		break;
			  	default:
						dump("\nBrowser Update: New extensions update style");
			  }
			}
		} catch (ex) { dump("\nBrowser Update Description Error: " + ex); }
	  
		try {
		  var browserUpdateButton = document.getElementById('browserUpdateButton');
		  var browserUpdateStatus = document.getElementById('browserUpdateStatus');
			
			if(this.CheckBrowserUpdatePrefs()) {
		  	// set button status
				browserUpdateButton.label = gUpdateBundle.getString('updateNowButton');
				
			  // set update status
				var updateSeverity = gPrefService.getIntPref("update.severity");
				switch(updateSeverity) {
					case 0:
						browserUpdateStatus.value = gUpdateBundle.getString('theme');
					break;
					case 1:
						browserUpdateStatus.value = gUpdateBundle.getString('extension');
					break;
					case 2:
						browserUpdateStatus.value = gUpdateBundle.getString('browser');
					break;
					default:
						dump("\nBrowser Update: New update severity\n");
				}
			}
			else {
			  // set button status
				browserUpdateButton.label = gUpdateBundle.getString('checkNowButton');
		
			  // set update status
				browserUpdateStatus.value = gUpdateBundle.getString('upToDate');
			}
		} catch (ex) { dump("\nBrowser Update Status Error: " + ex); }
	},

	CheckBrowserUpdatePrefs: function() {
		// determine if update(s) are available and set the memeber variable
		var updatesAvailable = gPrefService.getBoolPref('app.update.updatesAvailable');
		var lastAppLastUpdated = gPrefService.getIntPref('app.update.lastUpdateDate');
		var bCanUpdate = false;
	
		// if an update has been performed the update is not available anymore, we are
		// waiting for the user to restart the browser
		var updatePerformed = gPrefService.getBoolPref('app.update.performed');
	
		if (updatesAvailable && !updatePerformed)
			bCanUpdate = true;
	
		return bCanUpdate;
	}
}