<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:aNamespace="http://www.netscape.com/browser/desktopsearch/results" >
  
    <xsl:output method="xml" encoding="ISO-8859-1" indent="yes" />
           
    <!-- =============================================== -->
    <!--       COPY ACROSS ALL THE ELEMENTS OF THE XML RESULTS
                  AS WELL AS ADD IN A DERIVED ELEMENT CALLED
                 FILEGROUP                                                                                  -->
    <!-- =============================================== -->   
    <xsl:template match="aNamespace:DTS">
        <xsl:processing-instruction name="xml-stylesheet">
            href="chrome://browser/content/search/dsktop-search-results.xsl" type="text/xsl"
        </xsl:processing-instruction>
        <xsl:call-template name="copy"/>
    </xsl:template>
    
    <xsl:template match="searchInfo">
        <xsl:call-template name="copy"/>
    </xsl:template>
        
    <xsl:template match="Items">
        <xsl:call-template name="copy"/>
    </xsl:template>
    
    <xsl:template match="Item">
        <xsl:copy>
            <!-- DERIVE THE GROUPING BASED ON EXTENSION OF THE FILE
                   NEW ELEMENT: FILEGROUP-->
            <xsl:element name="FileGroup" >
                <xsl:choose> 
                    <xsl:when test="FileExt ='doc' "> Word Processing Files</xsl:when>
                    <xsl:when test="FileExt ='rtf' "> Word Processing Files</xsl:when>
                    <xsl:when test="FileExt ='txt' "> Word Processing Files</xsl:when>
                    <xsl:when test="FileExt ='wp' "> Word Processing Files</xsl:when>
                    <xsl:when test="FileExt ='xls' ">Spreadsheets</xsl:when>        
                    <xsl:when test="FileExt ='ppt' ">Presentations</xsl:when>                  
                    <xsl:when test="FileExt ='mp3' ">Music</xsl:when>
                    <xsl:when test="FileExt ='wav' ">Music</xsl:when>
                    <xsl:when test="FileExt ='mod' ">Music</xsl:when>
                    <xsl:when test="FileExt ='midi' ">Music</xsl:when>
                    <xsl:when test="FileExt ='wma' ">Music</xsl:when>        
                    <xsl:when test="FileExt ='gif' ">Pictures</xsl:when>    
                    <xsl:when test="FileExt ='jpg' ">Pictures</xsl:when>
                    <xsl:when test="FileExt ='jpeg' ">Pictures</xsl:when>
                    <xsl:when test="FileExt ='bmp' ">Pictures</xsl:when>
                    <xsl:when test="FileExt ='tiff' ">Pictures</xsl:when>
                    <xsl:when test="FileExt ='png' ">Pictures</xsl:when>
                    <xsl:when test="FileExt ='psd' ">Pictures</xsl:when>
                    <xsl:when test="FileExt ='psp' ">Pictures</xsl:when>    
                    <xsl:when test="FileExt ='avi' ">Videos</xsl:when>
                    <xsl:when test="FileExt ='mpg' ">Videos</xsl:when>
                    <xsl:when test="FileExt ='mpeg' ">Videos</xsl:when>        
                    <xsl:when test="FileExt ='pdf' ">PDF Documents</xsl:when>        
                    <xsl:when test="FileExt ='html' ">HTML</xsl:when> 
                    <xsl:otherwise>Other Documents</xsl:otherwise>
                </xsl:choose>
            </xsl:element>           
            <xsl:apply-templates select="@*" mode="copy" />
            <xsl:apply-templates/>
            <xsl:value-of select="text()"/>
        </xsl:copy>        
    </xsl:template>
        
    <xsl:template match="ItemId">
        <xsl:call-template name="copy"/>
    </xsl:template>
        
    <xsl:template match="DateModified">
        <xsl:call-template name="copy"/>
    </xsl:template>
    
    <xsl:template match="DateValue">
        <xsl:call-template name="copy"/>
    </xsl:template>
            
    <xsl:template match="FileName">
        <xsl:call-template name="copy"/>
    </xsl:template>
        
    <xsl:template match="FileSize">
        <xsl:call-template name="copy"/>
    </xsl:template>
        
    <xsl:template match="FileSizeBytes">
        <xsl:call-template name="copy"/>
    </xsl:template>    
    
    <xsl:template match="FileType">
        <xsl:call-template name="copy"/>
    </xsl:template>
    
    <xsl:template match="FileExt">
        <xsl:call-template name="copy"/>
    </xsl:template>
                
    <xsl:template match="Folder">
        <xsl:call-template name="copy"/>
    </xsl:template>
        
    <xsl:template match="ShortFolder">
        <xsl:call-template name="copy"/>
    </xsl:template>
        
    <xsl:template match="Url">
        <xsl:call-template name="copy"/>
    </xsl:template>
            
    <!-- =============================================== -->
    <!--               INTERNAL TEMPLATES                -->
    <!-- =============================================== -->
    
    
    <!-- create a root document, so the result is wellformed -->
    <xsl:template match="/">
            <xsl:apply-templates/>
    </xsl:template>
    
    
    <!-- copy one element with its attributes and apply templates for nested elements -->
    <xsl:template name="copy">        
        <xsl:copy>
            <xsl:apply-templates select="@*" mode="copy" />
            <xsl:apply-templates/>
            <xsl:value-of select="text()"/>
        </xsl:copy>
    </xsl:template>
    
    
    <!-- copy attributes -->
    <xsl:template match="@*" mode="copy">
        <xsl:copy/>
    </xsl:template>
    
    
    <!-- filters all undefined elements -->
    <xsl:template match="@*|*|text()">
        <xsl:apply-templates/>
    </xsl:template>
    
</xsl:stylesheet>