<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:aNamespace="http://www.netscape.com/browser/desktopsearch/results"
    xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
    xmlns:html="http://www.w3.org/TR/REC-html40">
    <xsl:output method="xml" encoding="ISO-8859-1" indent="yes"/>
    
    <xsl:template match="aNamespace:DTS">
        <xsl:processing-instruction name="xml-stylesheet"> href="chrome://browser/skin/"
            type="text/css" </xsl:processing-instruction>
        <page xmlns:html="http://www.w3.org/1999/xhtml"
            xmlns:aNamespace="http://www.netscape.com/browser/desktopsearch/results"
            onload="doLayout();"
            xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" title="Desktop
            Search" flex="1" style="-moz-box-flex: 1; -moz-box-orient: horizontal !important;">
            <script type="application/x-javascript"><![CDATA[

                    var showGroupsChkState = true;
                    
                    function processRequest(evt, requestType){
                            
                            if (evt.target.localName == 'menuitem'){
                                var tree =  document.popupNode.parentNode;
                            } else {
                                var tree =  evt.target.parentNode;
                            }
                                                
                            if (tree.currentIndex == -1) return;
                            if (requestType  == 1) {
                                var path = tree.view.getItemAtIndex(tree.currentIndex).getAttribute('filePath');                             
                            } else {
                                var path = tree.view.getItemAtIndex(tree.currentIndex).getAttribute('folderPath'); 
                            }                        
                            
                            setTimeout(function(){openFile(path);},500);                        
                    }       
                
                    function openFile(path){                
                        try  {                  
                            netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
                            var file = Components.classes["@mozilla.org/file/local;1"]
                            .createInstance(Components.interfaces.nsILocalFile);                                          
                            file.initWithPath(path);
                            file.launch();                    
                        }catch(e){                        
                                Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
                                getService(Components.interfaces.nsIPromptService).
                                alert(window, 
                                        document.getElementById("searchBundle").getString("searchPromptTitle"), 
                                        document.getElementById("searchBundle").getString("searchMsgFileOpenError"));			
                            
                            return false;                        
                        }	
                        return true;
                    }
                
                    function doLayout(){
                        var showGroupsChkBox = document.getElementById('chk-show-groups');                        
                        var sortByList = document.getElementById('lst-sort-by');   
                        var selectedSortBy = sortByList.value;
                        var showGroups = showGroupsChkBox.getAttribute('checked');
                        if (selectedSortBy == 'FileName' || selectedSortBy  == 'FileSize') {
                            showGroupsChkBox.hidden = true;
                            showGroups = false;                         
                        } else {
                             showGroupsChkBox.hidden = false;                           
                        }
                        var sections = document.getElementsByAttribute('section', 'true');
                                                                
                        for (var i=0;i!=sections.length;i++){
	                var section = sections[i];                               
                               var sortBy = section.getAttribute('sortBy');
                               var isGrouped = section.getAttribute('isGrouped');                                                              
                               if (sortBy == selectedSortBy){                                     
                                    if (isGrouped == showGroups) {                                        
                                        section.hidden = false;                                        
                                    } else {
                                        section.hidden = true;                                        
                                    }
                                } else {                                  
                                   section.hidden = true; 
                                }                               
                        }                                        
                    }
                function expandCollapse(btn) {
                    
                    var controlNode = btn.parentNode.parentNode;
                    if (controlNode.getAttribute('closed')){                        
                        controlNode.removeAttribute('closed');
                        controlNode.firstChild.nextSibling.nextSibling.hidden = false;
                        dump('showing collapsed');
                    } else {
                        controlNode.firstChild.nextSibling.nextSibling.hidden = true;
                        controlNode.setAttribute('closed', 'true');
                        dump('showing closed');                
                    }
                }
                
         ]]></script>
            <html:style type="text/css"><![CDATA[
            #resultsTable  {
                font-family: Arial; 
                padding-right: 10px;
                padding-left: 10px;
                padding-top:10px;
            }
                                        
            .fileName{
                padding-left:10px;                
                width:300px; 
             }
                
             .fileType{                
                width:200px; 
             }
                
             .fileSize{                
                width:150px; 
             }        
                
             .fileDate{                
                width:100px; 
             }         
                               
              .boldHeadingText {                
                font-size: 16px;   
                font-weight: bold;                
               }
                
                .headingText {                
                font-size: 14px;
                font-weight: bold;      
               }
                
                .selectionCriteriaText {
                font-size: 12px;        
                font-weight: bold; 
               }
                
               .groupHeaderText {
                color: White;
                font-size: 14px;    
                 font-weight: bold;                  
               }
              
                .groupHeaderHBOX {                    
                    background-color: #A9A9A9;        
                    background-image: url("chrome://browser/content/search/group_gradient.gif");
                   -moz-box-align:center;
               }
                
                .headerRowHBOX {
                      background-color: #F2F3F3;
                      padding-top: 5px;
                      padding-left: 5px;
                      padding-bottom: 2px;                                                 
                }                     
                                          
                .expand-collapse{
                       list-style-image: url("chrome://browser/content/search/collapse_btn.png");
                       padding-left: 5px;
                 }                         
                
                vbox  [closed] .expand-collapse {
                       list-style-image: url("chrome://browser/content/search/expand_btn.png");
                       padding-left: 5px;
                 }               
                
                treechildren::-moz-tree-cell-text {
                    padding-left: 5px; 
                }
               
                ]]></html:style>
            <label id="currentSelection" hidden="true"/>
            <stringbundle id="searchBundle" src="chrome://browser/locale/search/search-panel.properties"/>
            <popupset>
                <popup id="desktopMenu">
                    <menuitem label="Open" requestType="file"
                        oncommand="processRequest(event, 1);"/>
                    <menuitem label="Open Enclosing Folder" requestType="folder"
                        oncommand="processRequest(event, 2);"/>
                </popup>
            </popupset>
            <box style="overflow : auto; " flex="1">
                <vbox debug="false" id="resultsTable" flex="1">
                    <xsl:apply-templates select="searchInfo"/>
                    <xsl:apply-templates select="//Items" mode="FileGroup"/>
                    <xsl:apply-templates select="//Items" mode="Folder"/>
                    <xsl:apply-templates select="//Items" mode="DateModified"/>
                    <xsl:apply-templates select="//Items" mode="SortedByFileGroup"/>
                    <xsl:apply-templates select="//Items" mode="SortedByFolder"/>
                    <xsl:apply-templates select="//Items" mode="SortedByDateModified"/>
                    <xsl:apply-templates select="//Items" mode="SortedByFileName"/>
                    <xsl:apply-templates select="//Items" mode="SortedByFileSize"/>
                </vbox>
            </box>
        </page>
    </xsl:template>
    
    <!-- S E A R C H  I N F O-->
    <xsl:template match="searchInfo">
        <hbox class="headerRowHBOX">
            <vbox>
                <label class="boldHeadingText" value="Desktop Search"/>
                <spacer flex="1"/>
                <hbox align="center">
                    <label class="selectionCriteriaText" value="Sort Files By: "/>
                    <menulist id="lst-sort-by" oncommand="doLayout();">
                        <menupopup>
                            <menuitem value="FileGroup" label="Type"/>
                            <menuitem value="DateModified" label="Date"/>
                            <menuitem value="Folder" label="Folder"/>
                            <menuitem value="FileName" label="Name"/>
                            <menuitem value="FileSize" label="Size"/>
                        </menupopup>
                    </menulist>
                    <checkbox id="chk-show-groups" class="selectionCriteriaText" label="Show In
                        Groups" checked="true" oncommand="doLayout();"/>
                </hbox>
            </vbox>
            <spacer flex="1"/>
            <vbox>
                <spacer height="5px;"/>
                <hbox pack="end">
                    <label class="headingText" style="margin-right: 0px;padding-right:0px;">Results for: &quot;</label>
                        
                    <label class="headingText" style="margin-right:0px;margin-left:0px;padding-right:0px;padding-left:0px;max-width:200px;" crop="end">
                        <xsl:attribute name="value"><xsl:value-of
                                select="@searchText"/></xsl:attribute>
                    </label>
                    <label class="headingText" style="margin-left: 0px;padding-left:0px;">&quot;</label>
                </hbox>
                <spacer flex="1"/>
                <hbox pack="end">
                    <label class="headingText">
                        <xsl:attribute name="value">
                            <xsl:value-of select="@count"/> Items Found</xsl:attribute>
                    </label>
                </hbox>
            </vbox>
        </hbox>
    </xsl:template>
    
    <!-- G R O U P : FileGroup -->
    <xsl:key name="files-by-FileGroup" match="Item" use="FileGroup"/>
    <xsl:template match="Items" mode="FileGroup">
        <vbox flex="1" section="true" sortBy="FileGroup" isGrouped="true">
            <xsl:for-each select="Item[count(. | key('files-by-FileGroup', FileGroup)[1]) = 1]">
                <xsl:sort select="FileGroup"/>
                <!-- G R O U P  H E A D E R-->
                <spacer height="5px"/>
                <vbox>
                    <hbox class="groupHeaderHBOX">
                        <image class="expand-collapse" onclick="expandCollapse(this);"/>
                        <label pack="start" class="groupHeaderText"
                            style="padding-top:5px;padding-bottom:5px;padding-left:5px;  ">
                            <xsl:attribute name="value">
                                <xsl:value-of select="FileGroup"/>
                            </xsl:attribute>
                        </label>
                        <spacer flex="1"/>
                        <label pack="end" class="groupHeaderText"
                            style="padding-top:5px;padding-bottom:5px;padding-right:5px;  ">
                            <xsl:attribute name="value">(<xsl:value-of
                                    select="count(//FileGroup[.=current()/FileGroup])"
                            />)</xsl:attribute>
                        </label>
                    </hbox>
                    <spacer height="5px"/>
                    <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);" enableColumnDrag="true">
                        <xsl:attribute name="id"><xsl:value-of select="FileGroup"/>-<xsl:value-of
                            select="count(//FileGroup[.=current()/FileGroup])"
                            /></xsl:attribute>

                        <xsl:call-template name="treeCols">
                            <xsl:with-param name="idBase">FileGroup<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                        </xsl:call-template>
                        
                        <treechildren>
                            <xsl:for-each select="key('files-by-FileGroup', FileGroup)">
                                <xsl:sort select="FileName"/>
                                <xsl:call-template name="treeItem"/>
                            </xsl:for-each>
                        </treechildren>
                    </tree>
                </vbox>
            </xsl:for-each>
        </vbox>
    </xsl:template>
    
    <!-- SORTED : FileGroup -->
    <xsl:template match="Items" mode="SortedByFileGroup">
        <vbox flex="1" section="true" sortBy="FileGroup">
            <spacer height="5px"/>
            <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                <xsl:call-template name="treeCols">
                    <xsl:with-param name="idBase">SortedByFileGroup<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                </xsl:call-template>
                <treechildren>
                    <xsl:for-each select="Item">
                        <xsl:sort select="FileName"/>
                        <xsl:call-template name="treeItem"/>
                    </xsl:for-each>
                </treechildren>
            </tree>
        </vbox>
    </xsl:template>
    
    <!-- G R O U P : Folder -->
    <xsl:key name="files-by-Folder" match="Item" use="Folder"/>
    <xsl:template match="Items" mode="Folder">
        <vbox flex="1" section="true" sortBy="Folder" isGrouped="true">
            <xsl:for-each select="Item[count(. | key('files-by-Folder', Folder)[1]) = 1]">
                <xsl:sort select="Folder"/>
                <!-- G R O U P  H E A D E R-->
                <spacer height="5px"/>
                <vbox>
                    <hbox class="groupHeaderHBOX">
                        <image class="expand-collapse" onclick="expandCollapse(this);"/>
                        <label class="groupHeaderText"
                            style="padding-top:5px;padding-bottom:5px;padding-left:5px;  ">
                            <xsl:attribute name="value">
                                <xsl:value-of select="Folder"/>
                            </xsl:attribute>
                        </label>
                        <spacer flex="1"/>
                        <label pack="end" class="groupHeaderText"
                            style="padding-top:5px;padding-bottom:5px;padding-right:5px;  ">
                            <xsl:attribute name="value">(<xsl:value-of
                                select="count(//Folder[.=current()/Folder])"/>)</xsl:attribute>
                        </label>
                    </hbox>
                    <spacer height="5px"/>
                    <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                        <xsl:call-template name="treeCols">
                            <xsl:with-param name="idBase">Folder<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                        </xsl:call-template>
                        <treechildren>
                            <xsl:for-each select="key('files-by-Folder', Folder)">
                                <xsl:sort select="FileName"/>
                                <xsl:call-template name="treeItem"/>
                            </xsl:for-each>
                        </treechildren>
                    </tree>
                </vbox>
            </xsl:for-each>
        </vbox>
    </xsl:template>
    
    <!-- SORTED : Folder -->
    <xsl:template match="Items" mode="SortedByFolder">
        <vbox flex="1" section="true" sortBy="Folder">
            <spacer height="5px"/>
            <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                <xsl:call-template name="treeCols">
                    <xsl:with-param name="idBase">SortedByFolder<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                </xsl:call-template>
                <treechildren>
                    <xsl:for-each select="Item">
                        <xsl:sort select="Folder"/>
                        <xsl:call-template name="treeItem"/>
                    </xsl:for-each>
                </treechildren>
            </tree>
        </vbox>
    </xsl:template>
    
    <!-- G R O U P : DateModified -->
    <xsl:key name="files-by-DateModified" match="Item" use="DateValue"/>
    <xsl:template match="Items" mode="DateModified">
        <vbox flex="1" section="true" sortBy="DateModified" isGrouped="true">
            <xsl:for-each select="Item[count(. | key('files-by-DateModified', DateValue)[1]) = 1]">
                <xsl:sort select="DateValue" order="descending"/>
                <xsl:variable name="theDate">
                    <xsl:value-of select="DateModified"/>
                </xsl:variable>
                <!-- G R O U P  H E A D E R-->
                <spacer height="5px"/>
                <vbox>
                    <hbox class="groupHeaderHBOX">
                        <image class="expand-collapse" onclick="expandCollapse(this);"/>
                        <label class="groupHeaderText"
                            style="padding-top:5px;padding-bottom:5px;padding-left:5px;  ">
                            <xsl:attribute name="value">
                                <xsl:value-of select="substring-before($theDate,' ')"/>
                            </xsl:attribute>
                        </label>
                        <spacer flex="1"/>
                        <label pack="end" class="groupHeaderText"
                            style="padding-top:5px;padding-bottom:5px;padding-right:5px;  ">
                            <xsl:attribute name="value">(<xsl:value-of
                                select="count(//DateValue[.=current()/DateValue])"
                                />)</xsl:attribute>
                        </label>
                    </hbox>
                    <spacer height="5px"/>
                    <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                        <xsl:call-template name="treeCols">
                            <xsl:with-param name="idBase">DateModified<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                        </xsl:call-template>
                        <treechildren>
                            <xsl:for-each select="key('files-by-DateModified', DateValue)">
                                <xsl:sort select="FileName"/>
                                <xsl:call-template name="treeItem"/>
                            </xsl:for-each>
                        </treechildren>
                    </tree>
                </vbox>
            </xsl:for-each>
        </vbox>
    </xsl:template>
    
    <!-- SORTED : DateModified -->
    <xsl:template match="Items" mode="SortedByDateModified">
        <vbox flex="1" section="true" sortBy="DateModified">
            <spacer height="5px"/>
            <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                <xsl:call-template name="treeCols">
                    <xsl:with-param name="idBase">SortedByDateModified<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                </xsl:call-template>
                <treechildren>
                    <xsl:for-each select="Item">
                        <xsl:sort select="DateValue" order="descending"/>
                        <xsl:call-template name="treeItem"/>
                    </xsl:for-each>
                </treechildren>
            </tree>
        </vbox>
    </xsl:template>
    
    <!-- SORTED : FileName -->
    <xsl:template match="Items" mode="SortedByFileName">
        <vbox flex="1" section="true" sortBy="FileName">
            <spacer height="5px"/>
            <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                <xsl:call-template name="treeCols">
                    <xsl:with-param name="idBase">SortedByFileName<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                </xsl:call-template>
                <treechildren>
                    <xsl:for-each select="Item">
                        <xsl:sort select="FileName"/>
                        <xsl:call-template name="treeItem"/>
                    </xsl:for-each>
                </treechildren>
            </tree>
        </vbox>
    </xsl:template>
    
    <!-- SORTED : FileSize -->
    <xsl:template match="Items" mode="SortedByFileSize">
        <vbox flex="1" section="true" sortBy="FileSize">
            <spacer height="5px"/>
            <tree rows="6" contextmenu="desktopMenu" ondblclick="processRequest(event, 1);">
                <xsl:call-template name="treeCols">
                    <xsl:with-param name="idBase">SortedByFileSize<xsl:value-of select="generate-id(.)" /></xsl:with-param>
                </xsl:call-template>
                <treechildren>
                    <xsl:for-each select="Item">
                        <xsl:sort select="FileSizeBytes" data-type="number"/>
                        <xsl:call-template name="treeItem"/>
                    </xsl:for-each>
                </treechildren>
            </tree>
        </vbox>
    </xsl:template>
    
    <xsl:template name="treeItem">
        <!-- I T E M  S T A R T -->
        <treeitem>
            <xsl:attribute name="filePath">
                <xsl:value-of select="Url"/>
            </xsl:attribute>
            <xsl:attribute name="folderPath">
                <xsl:value-of select="Folder"/>
            </xsl:attribute>
            <xsl:attribute name="tooltiptext">
                <xsl:value-of select="Folder"/>
            </xsl:attribute>
            <treerow>
                <treecell src="chrome://browser/content/search/file.gif">
                    <xsl:attribute name="label">
                        <xsl:value-of select="FileName"/>
                    </xsl:attribute>
                </treecell>
                <treecell>
                    <xsl:attribute name="label">
                        <xsl:value-of select="Folder"/>
                    </xsl:attribute>
                </treecell>
                <treecell>
                    <xsl:attribute name="label">
                        <xsl:value-of select="FileType"/>
                    </xsl:attribute>
                </treecell>
                <treecell>
                    <xsl:attribute name="label">
                        <xsl:value-of select="FileSize"/>
                    </xsl:attribute>
                </treecell>
                <treecell>
                    <xsl:attribute name="label">
                        <xsl:value-of select="DateModified"/>
                    </xsl:attribute>
                </treecell>
            </treerow>
        </treeitem>
        <!-- I T E M  E N D -->
    </xsl:template>
    
    <xsl:template name="treeCols">
        <xsl:param name="idBase">default</xsl:param>
        <treecols>
            <treecol label="Name" primary="true" flex="4">
                <xsl:attribute name="id">
                    fileName-<xsl:value-of select="$idBase"/>
                </xsl:attribute>
            </treecol>
            <splitter class="tree-splitter"/>
            <treecol label="Folder" flex="4" hidden="true">
                <xsl:attribute name="id">
                    fileFolder-<xsl:value-of select="$idBase"/>
                </xsl:attribute>
            </treecol>
            <splitter class="tree-splitter"/>
            <treecol label="Type" flex="4">
                <xsl:attribute name="id">
                    fileType-<xsl:value-of select="$idBase"/>
                </xsl:attribute>
            </treecol>
            <splitter class="tree-splitter"/>
            <treecol label="Size" flex="3">
                <xsl:attribute name="id">
                    fileSize-<xsl:value-of select="$idBase"/>
                </xsl:attribute>
            </treecol>
            <splitter class="tree-splitter"/>
            <treecol id="fileDate" label="Date" flex="4">
                <xsl:attribute name="id">
                    fileDate-<xsl:value-of select="$idBase"/>
                </xsl:attribute>
            </treecol>
            <splitter class="tree-splitter"/>
        </treecols>
    </xsl:template>
</xsl:stylesheet>
