var desktopSearch = {
	
	// Set this to false to disable debug output
	SEARCH_DEBUG : true,
	
	DSKTOP_SRCH_RESULTS_HTML_FILE : "dsktop-search-results.html",
	DSKTOP_SRCH_RESULTS_XML_FILE : "dsktop-search-results.xml",
	DSKTOP_SRCH_RESULTS_XSL_FILE : "dsktop-search-results.xsl",
	
	// File open flags (from prio.h)
	PR_RDONLY : 1,
	PR_WRONLY : 2,
	PR_TRUNCATE : 4,
	CopernicyProxyService : null,	
	COPERNIC_PROXY_SVC_CID: "@netscape.com/browser/desktop-search;1",		
	gCopernicyProxyService: null,
	gSearchThreadId: null,
		             											
	debug : function(msg) {
		if (!this.prefService ||
		    (this.prefService.getPrefType("search.debug")) &&
		    (this.prefService.getBoolPref("search.debug")) )
		{
			dump('dsktop-search-utils.js: '+msg+'\n');
		}
	},
			
	GetProxyService : function() {
		
		try {			
			if (!this.gCopernicyProxyService) {
					this.gCopernicyProxyService = Components.classes["@netscape.com/browser/desktop-search;1"].getService(Components.interfaces.nsIDesktopSearch);
			}			
			return this.gCopernicyProxyService;
								
			
		}catch (e){
			this.logError(e,'GetProxyService() failed');				
		}	
		
		return this.CopernicyProxyService;				
	},
		       
	ClearFilters : function() {
  	
  	try{
  		this.GetProxyService().clearFilters();
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:ClearFilters()');				
		}		
  },
  
  FilterFileType : function(fileType) {
		try{
			this.debug('FilterFileType(' + fileType + ')');
 			this.GetProxyService().filterFileType(fileType);
 			
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterFileType(' + fileType + ')');				
		}						
  },
  
  FilterSizeLessThan : function(lessThan) {
  	try{
  		this.debug('filterSizeLessThan(' + lessThan + ')');
  		this.GetProxyService().filterSizeLessThan(lessThan);
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterSizeLessThan(' + lessThan + ')');						
		}  			
  },
  
  FilterSizeGreaterThan : function(greaterThan) {
  	try{
  		this.debug('FilterSizeGreaterThan(' + greaterThan + ')');
  		this.GetProxyService().filterSizeGreaterThan(greaterThan);
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterSizeGreaterThan(' + greaterThan + ')');						
		}  	  	
  },
  	
  FilterSizeBetween : function(minSize, maxSize) {
		try{
			this.debug('FilterSizeBetween(' + minSize + ',' + maxSize + ')');
			this.GetProxyService().filterSizeBetween(minSize, maxSize);  	
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterSizeBetween(' + minSize + ',' + maxSize + ')');						
		}  	  			
  },
  
  FilterDateOn : function(exactDate) {	
  	try{
  		this.debug('FilterDateOn(' + exactDate + ')');  		
  		this.GetProxyService().filterDateOn(exactDate * 1000);  	
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterDateOn(' + (exactDate * 1000) + ')');				
		}  	  	
  },

  FilterDateBefore : function(beforeDate) {
		try{
			this.debug('FilterDateBefore(' + beforeDate + ')');
  		this.GetProxyService().filterDateBefore(beforeDate * 1000);  	
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterDateBefore(' + (beforeDate * 1000) + ')');						
		}  	  			  	
  },
  
  

  FilterDateAfter : function(afterDate) {
  	try{
  		this.debug('FilterDateAfter(' + afterDate + ')');
  		this.GetProxyService().filterDateAfter(afterDate * 1000);  	  	
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterDateAfter(' + (afterDate* 1000) + ')');						
		}  	  			
  },
  
  
  FilterDateBetween : function(startDate, endDate) {	
  	try{
  		this.debug('FilterDateBetween(' + startDate + ',' + endDate + ')');
  		this.GetProxyService().filterDateBetween(startDate * 1000, endDate * 1000);  	  	
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterDateBetween(' + (startDate * 1000) + ',' + (endDate * 1000) + ')');						
		}  	  				  	  	  	  	
  },
  
  FilterPath : function(path) {
  	try{
  		this.debug('FilterPath(' + path + ')');
  		this.GetProxyService().filterPath(path);  	  	
		}catch (e){
			this.logError(e,'Copernic Proxy Service error:FilterPath(' + path + ')');						
		}  	  	  	  	
  },
  
	GetSearchInfo : function(dom, searchInfoType) {  	

	/*===================================================
		The caller can do getAttribute for the different 
		info surrounding a search
		e.g. GetSearchInfo(dom, 'count')
	===================================================*/															

		/*  count="" 
				searchText="" 
				filterFileType="" 
				filterPath="" 
				filterDateBefore="" 
				filterDateAfter="" 
				filterDateBetweenStart="" 
				filterDateBetweenEnd="" 
				filterDateOn="" 
				filterSizeBetweenMin="" 
				filterSizeBetweenMax="" 
				filterSizeGreaterThan="" 
				filterSizeLessThan="" */

		try {  		
  		return dom.getElementsByTagName('searchInfo')[0].getAttribute(searchInfoType);  	  			 		  		
  	}catch(e){  		
  		return null;  	
  	}  	  	  			
	},
	
  GetResultCount : function(dom) {  	  	
  	try {  		
  		var result = dom.getElementsByTagName('Item').length;  	
  	}catch(e){  		
  		return 0;  	
  	}  	  	
  	return result;
  },
  
  GetElementText : function(local, parentElem) {  
  	  	
    var result = parentElem.getElementsByTagName(local)[0];
    if (result) {
        return result.firstChild.nodeValue;            
    } else {
        return "n/a";
    }
	},
	
  CreateResultsRDF : function(dom) {
  	
  	var items = dom.getElementsByTagName('Item');	
  	
  	// get the XPCOM services we need to work with RDF's
		var RDF =
		Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
		RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);
		
		var RDFC = Components.classes['@mozilla.org/rdf/container;1'].getService();
		RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);
		
		var RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService();
		RDFCUtils =	RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);		
		
		var ds =Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance();					
		ds = ds.QueryInterface(Components.interfaces.nsIRDFDataSource);
		
		//RDF.RegisterResource(ds,false);
				
  	try {  		
  		 
  		 	//ds.BeginUpdateBatch();
				var rootNode = RDF.GetResource("urn:root");
				var seqNode = RDF.GetResource("urn:root:seq");
				
				// insert the "top" of the tree, a Seq container
				ds.Assert(rootNode,	RDF.GetResource("http://www.netscape.com/RDF#searchresults"),	seqNode, true);
				
				RDFCUtils.MakeSeq(ds, seqNode);
				RDFC.Init(ds, seqNode);
																			
				for (var i = 0; i < items.length; i++) {
								
					var newURI = "urn:root:file:" + i;
										
					var ItemId = this.GetElementText("ItemId", items[i]);
					var FileName = this.GetElementText("FileName", items[i]);
		    	var DateModified = this.GetElementText("DateModified", items[i]);
		    	var FileSize = this.GetElementText("FileSize", items[i]);
		    	var FileType = this.GetElementText("FileType", items[i]);
		    	var Folder = this.GetElementText("Folder", items[i]);  
		    	var URL = this.GetElementText("Url", items[i]);  
		    										
					// add the new element
					RDFC.AppendElement(RDF.GetResource(newURI));
					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#ItemId"), RDF.GetLiteral(ItemId), true);					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#FileName"), RDF.GetLiteral(FileName), true);					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#DateModified"), RDF.GetLiteral(DateModified), true);					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#FileSize"), RDF.GetLiteral(FileSize), true);					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#FileType"), RDF.GetLiteral(FileType), true);					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#Folder"), RDF.GetLiteral(Folder), true);					
					ds.Assert(RDF.GetResource(newURI), RDF.GetResource("http://www.netscape.com/RDF#Url"),	RDF.GetLiteral(URL), true);
				
				}
				
				//ds.EndUpdateBatch();
							  		
  	}catch(e){  		  		
  		return null;  	
  	}  	  	
  	return ds;  	
  },
  
    CreateResultsArray : function(dom) {
  	
  	var items = dom.getElementsByTagName('Item');	
  	
  	var datatable = new Array();
  	  	 
  	try {  		
  		 																							
				for (var i = 0; i < items.length; i++) {
																														    			    	
		    	datatable.push(new Array(
		    													this.GetElementText("FileName", items[i])
		    													,this.GetElementText("Folder", items[i])
		    													,this.GetElementText("FileSize", items[i])
		    													,this.GetElementText("FileType", items[i])
		    													,this.GetElementText("Url", items[i])
		    													,this.GetElementText("DateModified", items[i])		    												
		    													,this.GetElementText("ItemId", items[i])
		    													,this.GetElementText("FileSizeBytes", items[i])
		    													)
		    								);		    			    					
				}										
							  		
  	}catch(e){  		  		
  		return null;  	
  	}  	  	
  	return datatable;  	
  },
  


	ExecuteSearch : function(searchText, callbackFunc) {

		this.debug('ExecuteSearch(' + searchText + ')');
		
		//Determine if desktopSearch is present
		//alert("ExecuteSearch : function(searchText, callbackFunc): " +
		//	"\nisDesktopSearchAvailable" + isDesktopSearchAvailable() );
		

																									
		/*===================================================
			Initialize copernic and execute search
		===================================================*/											
		try {										
			this.GetProxyService().initialize();			
			this.GetProxyService().executeSearch(searchText, true);
			this.PollForResults(callbackFunc);
		}catch (e){
			this.logError(e,'Error on call to copernic executeSearch');
		}																			
	},
	
	isSearchComplete : function() {		
		return this.GetProxyService().isAsyncComplete();
	},
	
	StopCurrentSearch : function () {    	
		try {			
	  	if (gSearchThreadId){
	  			clearTimeout(gSearchThreadId);  			
	  			this.debug('StopCurrentSearch() killing thread no: ' + gSearchThreadId);
	  			this.GetProxyService().killAsync();
	  	}
	  	gSearchThreadId = null;   	
		}  	
  	catch (e){}
  		  		
  },
	
	PollForResults : function (callbackFunc) {		
		this.debug('PollForResults()');		
		if(this.isSearchComplete()){
				this.debug('Results retrieved so calling function');
				gSearchThreadId = null;				
				setTimeout(callbackFunc,1000);	
		} else {
			this.debug('Polling for results');
			gSearchThreadId = setTimeout(function(){desktopSearch.PollForResults (callbackFunc);}, 2000);								
			this.debug('polling with thread no: ' + gSearchThreadId);						
		}				
	},
		
	Finalize : function() {
		
		/*===================================================
		 Finalize copernic
		===================================================*/				
		try {
			this.debug('Closing component...');
			this.GetProxyService().close();	
			this.debug('Close complete');							
		}catch (e){
			this.logError(e,'Error closing copernic component');							
		}		
	},
	
	RetrieveResults : function() {
				
		/*===================================================
	   Parse the results into a dom fragment
	  ===================================================*/			
		try {								
				var searchResultsText = this.GetProxyService().retrieveResults(0);						
		}catch (e){
			this.logError(e,'Error encountered on call to copernic retrieveResults');						
		}
	
		/*===================================================
	   Parse the results into a dom fragment
	  ===================================================*/						
	  try{
			var doc = this.ParseXMLStringToDoc(searchResultsText);								
		}catch (e){
			this.logError(e,'Error encountered on call to copernic retrieveResults');						
		}
				
		return doc;		
	},
	
	initXSLTParserFromStylesheet : function (stylesheetURI)
	{
		thisRequest = new XMLHttpRequest();			  			  
	  thisRequest.open("GET", stylesheetURI, false);
	  thisRequest.send(null);
	  
	  resultXSLTProcesser = new XSLTProcessor();							  			  
	  resultXSLTProcesser.importStylesheet(thisRequest.responseXML);	
	  return resultXSLTProcesser;
		
	},
	
	CreateResultsPage : function(resultsDom) {

		  /*===================================================
			   Creating the results page includes the following
			   1. Applying a stylesheet that adds the derived groups into the xml
			   2. Applying another stylesheet to the result to format
			   		the search results into a XUL document fragment
			   3. Serializing the document fragment
			   4. Writing to a file
			   5. Return the file path to the caller
		  ===================================================*/
		  		
		  try {			  
		  	
			  /*===================================================
			   Create the stylesheet for the grouping
			  ===================================================*/
			  var addGroupXSLTProcessor = this.initXSLTParserFromStylesheet(
			  	"chrome://browser/content/search/dsktop-search-results-add-groups.xsl");
			  var groupedResultsDOM = addGroupXSLTProcessor.transformToDocument(resultsDom);		 		  	
			  this.debug('Sucess: Groups added ' + groupedResultsDOM );
		  			  				  	 				
			  /*===================================================
			   Create the stylesheet for the formatted results
			  ===================================================*/
			  var formattingProcessor = this.initXSLTParserFromStylesheet(  
			  	"chrome://browser/content/search/dsktop-search-results.xsl");	  			  
			  var transformedResults = formattingProcessor.transformToFragment(groupedResultsDOM, document);
				this.debug('Sucess: Results formatted ' + transformedResults );
														
			  var serializer = new XMLSerializer();
	 			var serializedResults = serializer.serializeToString(transformedResults);		
								  			  						
				var path = this.WriteResultsToFile(serializedResults);		
				this.debug('path =' + path);

			}catch (e){
				this.logError(e,'Error creating search results page');							
			}						
			
			return path;
	},
	
		CreateResultsDOM : function(resultsDom) {

		  /*===================================================
			   Creating the results page includes the following
			   1. Applying a stylesheet that adds the derived groups into the xml
			   2. Applying another stylesheet to the result to format
			   		the search results into a XUL document fragment
			   3. Serializing the document fragment
			   4. Writing to a file
			   5. Return the file path to the caller
		  ===================================================*/
		  		
		  try {			  
		  	
		  	
			  /*===================================================
			   Create the stylesheet for the grouping
			  ===================================================*/
			  var addGroupXSLTProcessor = this.initXSLTParserFromStylesheet(
			  	"chrome://browser/content/search/dsktop-search-results-add-groups.xsl");
			  var groupedResultsDOM = addGroupXSLTProcessor.transformToDocument(resultsDom);		 		  	
			  this.debug('Sucess: Groups added ' + groupedResultsDOM );
		  			  				  	 				
			  /*===================================================
			   Create the stylesheet for the formatted results
			  ===================================================*/
			  var formattingProcessor = this.initXSLTParserFromStylesheet(  
			  	"chrome://browser/content/search/dsktop-search-results.xsl");	  			  
			  var transformedResults = formattingProcessor.transformToFragment(groupedResultsDOM, document);
				this.debug('Sucess: Results formatted ' + transformedResults );
														
			  var serializer = new XMLSerializer();
	 			var serializedResults = serializer.serializeToString(transformedResults);		
	 			
	 			return this.ParseXMLStringToDoc(serializedResults);
								  			  						
				//var path = this.WriteResultsToFile(serializedResults);		
				//this.debug('path =' + path);

			}catch (e){
				this.logError(e,'Error creating search results page');							
			}						
			
			return transformedResults;
	},

	
	WriteResultsToFile : function(searchResultsText) {
	
		this.debug('WriteResultsToFile()');
		
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
				                    
		file.append("dsktop-search-results.xul");		
		file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);			
		this.debug('Created temp file:' + file.path); 		
						
		var fos = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);                     
		this.debug('Writing results to temp file:' + file.path); 				                    
		fos.init(file, this.PR_WRONLY, 0, 0);				
		fos.write(searchResultsText, searchResultsText.length);
		fos.close();
		this.debug('Closing temp file:' + file.path); 				                    
		return file.path;
		
	},
	
	//This function returns a DOM document object
	ParseXMLStringToDoc : function(searchResultsText) {
	
		this.debug('ParseXMLStringToDoc('+ searchResultsText + ')');
				
		var parser = new DOMParser();
		var doc = parser.parseFromString(searchResultsText, "text/xml");
		this.debug('Parsing search results into DOM complete\n\n');
		
		var roottag = doc.documentElement;
		if ((roottag.tagName == "parserError") ||
    	(roottag.namespaceURI == "http://www.mozilla.org/newlayout/xml/parsererror.xml")){
  		this.debug('Error parsing results into DOM \n\n');  		
  		
		}							
		
		return doc;		
	},
	
	logError : function(exceptionObject, optionalAdditionalText) {	
	// logs (or otherwise handles) errors
    // do logging ?!
    // for now, just alert
    var output;
    var errSource = this.logError.caller;    //Source function from the error

    output = "Function: " + errSource.name ;

    if (errSource.arity > 0){
        output +=    "\nArguments: \n";        
        for (i=0; i < errSource.arity; i++){
            output += "   (" + i + ") " + errSource.arguments[i] ;
        }
    }
    output += "\nException: " + exceptionObject.message ;

    if (optionalAdditionalText !== null) {
        output += "\nNotes: " + optionalAdditionalText;
    }
    this.debug("\n" + output);   
    //alert (output);   
	}, 
	
	isDesktopSearchAvailable : function() {			
		
		try {						
			var result = this.GetProxyService().isAvailable();						
			this.debug('Copernic installed? ' + result);			
		} catch (e) {
			this.debug('Copernic not installed' + e.message);			
			return false;
		}
		
		return result;
		/*===================================================
	   MERC (RT) Query the registry for the existance of a Copernic
	   installation. It looks for the clsid. This should be 
	   enhanced to make use of a threshold version or specific
	   clsid set via a browser pref. It also does not 
	   take into account whether the logged in user has access 
	   to the application	   
	  ===================================================*/		  			  						
    /*try {    	      
    	
    	// nsIWindowsShellService.idl registry constants
    	//HKCR = 0; // HKEY_CLASSES_ROOT
			//HKCC = 1; // HKEY_CURRENT_CONFIG
			//HKCU = 2; // HKEY_CURRENT_USER
			//HKLM = 3; // HKEY_LOCAL_MACHINE
			//HKU  = 4; // HKEY_USERS
    	                 	
			var reg = Components.classes["@mozilla.org/browser/shell-service;1"].
								getService(Components.interfaces.nsIWindowsShellService);
						
			// HKEY_LOCAL_MACHINE\SOFTWARE\Copernic\DesktopSearch\System - BuildNumber
										
			var keyClsid = "\\CopernicDesktopSearchLib.CopernicDesktopSearch\\Clsid"
			var version = reg.getRegistryEntry(Components.interfaces.nsIWindowsShellService.HKCR, keyClsid, "");									
			debug('Copernic is installed');
			return true;		
		} catch (e) {
			debug('Copernic not installed');			
			return false;			
		}	*/
	} 
			
};