/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is 
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *    Robert John Churchill   <rjc@netscape.com> (Original Author)
 *    Peter Annema            <disttsc@bart.nl>
 *    Blake Ross              <blakeross@telocity.com>
 *    Ben Goodger             <ben@netscape.com>
 *    Rob Ginda               <rginda@netscape.com>
 *    Steve Lamm              <slamm@netscape.com>
 *    Samir Gehani            <sgehani@netscape.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or 
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const ISEARCH_CONTRACTID       = "@mozilla.org/rdf/datasource;1?name=internetsearch";
const RDFSERVICE_CONTRACTID    = "@mozilla.org/rdf/rdf-service;1";
const BMARKS_CONTRACTID        = "@mozilla.org/browser/bookmarks-service;1";


MAX_HISTORY_SIZE = 10;
DSKTOP_SEARCH_FLDR_HISTORY_FILE = "desktop-search-fldr-history.txt";
SEARCH_HISTORY_FILE = "search-history.txt";

profileDir = null;

// File open flags (from prio.h)
PR_RDONLY = 1;
PR_WRONLY = 2;
PR_TRUNCATE = 4;

const VAL_DESKTOP_SEARCH_ID = 'DesktopSearch';

const   VAL_ANY = "any"
const   VAL_DISPLAY_ANY =  "Any"
const 	VAL_FILE_TYPE_HTML= "html";
const 	VAL_FILE_TYPE_PDF = "pdf"; 
const 	VAL_FILE_TYPE_DOC = "doc"; 
const 	VAL_FILE_TYPE_RTF = "rtf"; 
const 	VAL_FILE_TYPE_WP=   "wp";
const 	VAL_FILE_TYPE_XLS=  "xls"; 
const 	VAL_FILE_TYPE_PPT=  "ppt"; 
const 	VAL_FILE_TYPE_TXT=	"txt";

const 	VAL_FILE_SIZE_SMALL = "small";
const 	VAL_FILE_SIZE_MED = "medium"; 
const 	VAL_FILE_SIZE_LG = "large";  
const 	VAL_FILE_SIZE_CUSTOM = "custom"; 	
const 	VAL_FILE_SIZE_CUSTOM_AT_LEAST = "atleast"; 
const 	VAL_FILE_SIZE_CUSTOM_AT_MOST = "atmost"; 
		
const 	VAL_FILE_DATE_TODAY = "today";
const 	VAL_FILE_DATE_YSTRDAY = "yesterday";
const 	VAL_FILE_DATE_THIS_WEEK = "thisweek"; 
const 	VAL_FILE_DATE_THIS_MONTH = "thismonth";
const 	VAL_FILE_DATE_THIS_YEAR = "thisyear"; 
const 	VAL_FILE_DATE_IS = "is" ;
const 	VAL_FILE_DATE_AFTER = "after" ;
const 	VAL_FILE_DATE_BEFORE = "before" ;
const 	VAL_FILE_DATE_BETWEEN = "between";
	
const nsIBookmarksService      = Components.interfaces.nsIBookmarksService;
const nsIRDFService            = Components.interfaces.nsIRDFService;
const nsIRDFLiteral            = Components.interfaces.nsIRDFLiteral;
const nsIRDFDataSource         = Components.interfaces.nsIRDFDataSource;
const nsIRDFRemoteDataSource   = Components.interfaces.nsIRDFRemoteDataSource;
const nsIInternetSearchService = Components.interfaces.nsIInternetSearchService;

const DEBUG = true;

// colName:[display column index, sort column index, order, isnumber]
var datacols = {FileName:[0,0,0,0],Folder:[1,1,0,0],FileSize:[2,7,0,1],FileType:[3,3,0,0]};

var debug;
if (!DEBUG)
{
  debug = function(msg) {};
}
else
{
  debug = function(msg)
  {
    dump("\t ^^^ search-panel.js: " + msg + "\n");
  };
}

var rootNode;
var textArc;
var modeArc;
var searchBundle;
var regionalBundle;
var gSearchButtonText = null;
var gStopButtonText = null;
var whitespace = " \t\n\r";

var sidebarInitiatedSearch = false;
var gDesktopSearchThreadId=null;


function showStack() {
	dump("\n STACK DUMP: \n");
	try {
		var borkbork = 1 / 0;
		var foobar;
		foobar.Cannibal;
		throw "foobar";
	} catch (e){
		dump(e.stack);
	}
}
// This gets called when page loads or rdf loaded.
function rememberSearchText(target)
{
  if (sidebarInitiatedSearch) {
    // this avoids updating the sidebar textbox twice
    return;
  }
  if (target) {
    target = target.QueryInterface(nsIRDFLiteral).Value;
    if (target) {
      // convert plusses (+) back to spaces
      target = target.replace(/\+/g, " ");
      var textNode = document.getElementById("sidebar-search-text");			
      textNode.value = decodeURIComponent(target);
    }
  }
  // show the results tab
  switchTab(0);
}

function getIndexToSelect(haveDefault, defaultEngine, enginePopup)
{
	if (haveDefault)
	{
		// iterate over constrained engine list for a default engine match
		for (var i = 0; i < enginePopup.childNodes.length; ++i)
		{
			if (enginePopup.childNodes[i].id == defaultEngine)
			{
				// found match with default engine!
				return i;
			}
		}
	}

	return 0; // default to first engine at index '0'
}

function selectMenuItemByValue(menuListID, valueForMatch, defaultToFirstIfNotFound)
{		
		var target = 	document.getElementById(menuListID);			
		
		items = target.firstChild.childNodes;
			
		if (items.length == 0){return;}
		
		for (var i = 0; i < items.length; ++i)
		{
			var currentValue = items[i].value;
									
			if (currentValue == valueForMatch)
			{				
				target.selectedItem = items[i];	
				return true;
				
			}
		}	
	
	if (defaultToFirstIfNotFound){
		target.selectedIndex = 0;
	}else {
		target.selectedIndex = -1;  //default to first item
		if (target.getAttribute('editable')){
			target.inputField.value = '';				
		}
	}
	
	return false;
	
}

function getMinVer()
{
  var minVerStr = nsPreferences.
    copyUnicharPref("browser.search.basic.min_ver");
  var minVer = parseFloat(minVerStr);
  if (isNaN(minVer)){
    minVer = 0; // no pref or not a number so default to min ver 0.0
	}
  debug("Float value of minVer = " + minVer);
  return minVer;
}

function getMenuListSelectedValue(menuListID){		
		
	var target = 	document.getElementById(menuListID);
	try {			
			if (target.selectedIndex > -1) {
				return target.selectedItem.value;			
			}else if (target.getAttribute('editable') && target.inputField.value){			 
				return target.value;
			}else {
				return null;
			}										
  	}  	
  	catch(e){
  		debug("getMenuListSelectedValue("+ menuListID + ")failed. \n");		
  		throw e;		
		}			
}	

function clearMenuItemSelection(menuListID){
	
	var target = 	document.getElementById(menuListID);
		
	target.selectedIndex = -1;
	if (target.getAttribute('editable')){
		target.inputField.value = '';
	}
}

function show_props(obj, obj_name) {
          var result = "";
          for (var i in obj){
                    result += obj_name + "." + i + " = " + obj[i] + "\n";
          }
          return result;
}
    
function getFolderMenu(){	
	return document.getElementById("folderMenu");	
}

//http://kb.mozillazine.org/Dev_:_nsIFilePicker
function openFolderPicker(){
	
	var nsIFilePicker = Components.interfaces.nsIFilePicker;	
	var fp = Components.classes["@mozilla.org/filepicker;1"]
		.createInstance(nsIFilePicker);
	fp.init(window, "Choose folder to search.", nsIFilePicker.modeGetFolder);
	//fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);
	
	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK)
	{
	  var file = fp.file; 
	  AddToHistory(file.persistentDescriptor, DSKTOP_SEARCH_FLDR_HISTORY_FILE);	
	  getFolderMenu().value = file.persistentDescriptor;
	  // work with returned nsILocalFile...
	}else {
		getFolderMenu().selectedIndex = -1;	
	}
	
}

function AddToHistory (value, fileName) {
//function AddToHistory (value) {
    debug('AddToHistory("'+value+'")');

    // If it's whitespace, don't bother
    if (!trim(value).length){ return;}

    // Create the new list
    var oldList = ReadHistory(fileName);
    var newList = new Array();
    newList[0] = value;
    for (var i = 0; i < oldList.length; i++) {
            if (oldList[i] != value){
							newList[newList.length] = oldList[i];
            }
            if (newList.length >= MAX_HISTORY_SIZE){break;}
    }

    // Open the history file for writing
    var file = GetHistoryFile(fileName);
    file.remove(false);
    file = EnsureHistoryFileExists(fileName);
    var fos = Components.classes["@mozilla.org/network/file-output-stream;1"]
                        .createInstance(Components.interfaces.nsIFileOutputStream);
    fos.init(file, PR_WRONLY, 0, 0);
    var contents = newList.join('\n');
    debug(' - writing contents:\n'+contents+'\n\n');
    fos.write(contents, contents.length);
    fos.close();
}

function ReadHistory(fileName){

        debug("ReadSearchHistory(" + fileName + ")");

        var file = EnsureHistoryFileExists(fileName);

        // Init the file input stream
        var fis = Components.classes["@mozilla.org/network/file-input-stream;1"]
                            .createInstance(Components.interfaces.nsIFileInputStream);
        fis.init(file, PR_RDONLY, 0, 0);

        // Init a scriptable input stream
        var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
                            .createInstance(Components.interfaces.nsIScriptableInputStream);
        sis.init(fis);

        // Read the file
        var fileContents = sis.read(sis.available());

        // Close file
        fis.close();

        // Return the lines as an array
        return fileContents.split('\n');
		
}

function GetHistoryFile(fileName) {
								
        debug('GetSearchHistoryFile(): '+ fileName );
        
				// Get the user's profile directory
        if (!profileDir) {
                profileDir = Components.classes["@mozilla.org/file/directory_service;1"]
                                            .getService(Components.interfaces.nsIProperties)
                                            .get("ProfD", Components.interfaces.nsILocalFile);
        }
        debug(' profileDir: '+profileDir.path);
        
        // Create file descriptor        
        var file = profileDir.clone();
        file.append(fileName);        
        return file; // returns nsILocalFile
}


function EnsureHistoryFileExists (fileName) {
        debug("EnsureSearchHistoryFileExists(" + fileName + ")");        
        var file = GetHistoryFile(fileName);
        if (!file.exists()) {
                debug(' creating file: '+ fileName);
                file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0);
        }
        return file; // returns nsILocalFile
}

function PopulatePopupFromFile (popupID, fileName) {
        
        debug("PopulateHistoryPopup(" + popupID + "," + fileName + ")");
				var popup = document.getElementById(popupID);  // var popup = evt.target;
								                
        // Purge the history menu
        while (popup.lastChild){
					popup.removeChild(popup.lastChild);
				}                

        // Load in the fresh history items
        var entries = ReadHistory(fileName);
        for (var i = 0; i < entries.length; i++) {
                if (!entries[i].length) {continue;}
                var newItem = document.createElement('menuitem');
                newItem.setAttribute('label', entries[i]);
                newItem.setAttribute('value', entries[i]);
                newItem.setAttribute('oncommand', 'HistoryCommand("'+entries[i]+'");');
                popup.appendChild(newItem);
        }                         
}

function PopulateFolderHistoryPopup (){
		 
	 debug("PopulateFolderHistoryPopup()");	 
	 PopulatePopupFromFile('folderHistoryPopup', DSKTOP_SEARCH_FLDR_HISTORY_FILE);
}

function PopulateSearchHistoryPopup (){
	
	debug('PopulateSearchHistoryPopup() start');
	var popup = document.getElementById("searchHistoryPopup"); 
	PopulatePopupFromFile('searchHistoryPopup', SEARCH_HISTORY_FILE);	    
	 
 	// Only add the separator if there were history items
	if (popup.lastChild){
		popup.appendChild(document.createElement('menuseparator'));}

	// Always add the 'clear history' menu item
	var clearHist = document.createElement('menuitem');
	clearHist.setAttribute('label', 'Clear Search History');
	clearHist.setAttribute('id', 'search-panel-clear-hist');
	clearHist.setAttribute('value', 'search-panel-clear-hist');
	clearHist.setAttribute('oncommand', 'ClearSearchHistory();');

	// ... but if there were no history items, then make it disabled
	if (!popup.lastChild){
		clearHist.setAttribute('disabled','true');}
	popup.appendChild(clearHist);	
	debug('PopulateSearchHistoryPopup() complete');

}

function ClearSearchHistory(){

	ClearHistory(SEARCH_HISTORY_FILE);
		
	var searchbar = window.top.document.getElementById('searchbar');	
	if (searchbar){
		searchbar.clear();}
	
	var sidesearchbar = document.getElementById('sidebar-search-text');	
	sidesearchbar.selectedIndex = -1;	
}

function ClearHistory (fileName) {
		debug('ClearSearchHistory()');					
		var file = GetHistoryFile(fileName);
		if (file.exists()) {
			// Init the file input stream
			var fis = Components.classes["@mozilla.org/network/file-input-stream;1"]
			                    .createInstance(Components.interfaces.nsIFileInputStream);
			fis.init(file, this.PR_RDONLY, 0,
			         Components.interfaces.nsIFileInputStream.DELETE_ON_CLOSE);
			fis.close();
	}
}
          
function PopulateHistoryPopup (evt, fileName) {
        debug("PopulateHistoryPopup(" + fileName + ")");

        // Purge the history menu
        var popup = evt.target;
        while (popup.lastChild){
              popup.removeChild(popup.lastChild);}

        // Load in the fresh history items
        var entries = ReadHistory(fileName);
        for (var i = 0; i < entries.length; i++) {
                if (!entries[i].length) {continue;}
                var newItem = document.createElement('menuitem');
                newItem.setAttribute('label', entries[i]);
                newItem.setAttribute('oncommand', 'HistoryCommand("'+entries[i]+'");');
                popup.appendChild(newItem);
        }        
        
}


function HistoryCommand (value) {
        debug('HistoryCommand("'+value+'")');
        var searchbar = document.getElementById('searchbar');
        if (searchbar) {
                // Put the value into the text box
                searchbar.mTextbox.value = value;
                // Execute search
                searchbar.mTextbox.onTextEntered();
        }
}

 function trim(str) {
        if (!str) {return "";}
        str = str.replace(/^\s+/, "");
        return str.replace(/\s+$/, "");
}

function readRDFString(aDS,aRes,aProp) {
	// Put in try catch incase aDS is not a the right type
	try {
		var n = aDS.GetTarget(aRes, aProp, true);
  	if (n){return n.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
  } catch (ex) {
  }
  return null;
}


function ensureDefaultEnginePrefs(aRDF,aDS) 
{
  var prefbranch = Components.classes["@mozilla.org/preferences-service;1"]
                             .getService(Components.interfaces.nsIPrefBranch);
  var defaultName = prefbranch.getComplexValue("browser.search.defaultenginename",
                                               Components.interfaces.nsIPrefLocalizedString).data;
  var kNC_Root = aRDF.GetResource("NC:SearchEngineRoot");
  var kNC_child = aRDF.GetResource("http://home.netscape.com/NC-rdf#child");
  var kNC_Name = aRDF.GetResource("http://home.netscape.com/NC-rdf#Name");
          
  var arcs = aDS.GetTargets(kNC_Root, kNC_child, true);
  while (arcs.hasMoreElements()) {
    var engineRes = arcs.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var name = readRDFString(aDS, engineRes, kNC_Name);
    if (name == defaultName){
      prefbranch.setCharPref("browser.search.defaultengine", engineRes.Value);
    }
  }
}


// Depricated
function AskChangeDefaultEngine(aSelectedEngine)
{
  const kDontAskAgainPref  = "browser.search.set_default.dont_ask_again";
  const kDefaultEnginePref = "browser.search.defaultengine";

  // don't prompt user if selection is same as old default engine
  var oldDefault = nsPreferences.copyUnicharPref(kDefaultEnginePref);
  if (aSelectedEngine.getAttribute("value") == oldDefault){
    return;
	}
  // check "don't ask again" pref
  var dontAskAgain = nsPreferences.getBoolPref(kDontAskAgainPref, false);
  var change = false; // should we change the default engine?

  // if "don't ask again" pref was set
  if (dontAskAgain)
  {
    change = true;
  }
  else
  {
    // prompt user if we should change their default engine
    var promptSvc = Components.
                      classes["@mozilla.org/embedcomp/prompt-service;1"].
                      getService(Components.interfaces.nsIPromptService);
    if (!promptSvc){
      return;
    }
    var title = searchBundle.getString("changeEngineTitle"); 
    var dontAskAgainMsg = searchBundle.getString("dontAskAgainMsg"); 
    var engineName = aSelectedEngine.getAttribute("label");
    if (!engineName || engineName == ""){
      engineName = searchBundle.getString("thisEngine");
    }
    var changeEngineMsg = searchBundle.stringBundle.formatStringFromName(
                          "changeEngineMsg", [engineName], 1); 

    var checkbox = {value:0};
    change = promptSvc.confirmCheck(window, title, changeEngineMsg, 
               dontAskAgainMsg, checkbox);

    // store "don't ask again" pref from checkbox value (if changed)
    debug("dontAskAgain: " + dontAskAgain);
    debug("checkbox.value: " + checkbox.value);
    if (checkbox.value != dontAskAgain){
      nsPreferences.setBoolPref(kDontAskAgainPref, checkbox.value);
    }
  }

  // if confirmed true, i.e., change default engine, then set pref
  if (change){
		nsPreferences.setUnicharPref(kDefaultEnginePref, aSelectedEngine.value);
  }

}

function ensureSearchPref()
{
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                      .getService(Components.interfaces.nsIRDFService);
  var prefbranch = Components.classes["@mozilla.org/preferences-service;1"]
                             .getService(Components.interfaces.nsIPrefBranch);
  var ds = rdf.GetDataSource("rdf:internetsearch");
  var kNC_Name = rdf.GetResource("http://home.netscape.com/NC-rdf#Name");
  var defaultEngine;

  try {
    defaultEngine = "DesktopSearch";
  } catch(ex) {
    ensureDefaultEnginePrefs(rdf, ds);
    defaultEngine = "DesktopSearch";
  }
}

// Initialize the Search panel:
// 1) init the category list
// 2) load the search engines associated with this category
// 3) initialize the checked state of said engines
function SearchPanelStartup()
{
	debug("SearchPanelStartup();");
  searchBundle = document.getElementById("searchBundle");
  
  var rdf  = Components.classes[RDFSERVICE_CONTRACTID].getService(nsIRDFService);
  rootNode = rdf.GetResource("NC:LastSearchRoot", true);
  textArc  = rdf.GetResource("http://home.netscape.com/NC-rdf#LastText", true);
  modeArc  = rdf.GetResource("http://home.netscape.com/NC-rdf#SearchMode", true);
  
  // ensureSearchPref();
  
//  var resultList = document.getElementById("resultList");
//  resultList.database.AddObserver(RDF_observer); 
                          
	document.getElementById("start-date-text").filter ='{{date}}';
	document.getElementById("end-date-text").filter ='{{date}}';
          
  // MERC (ccampbell): now observes a broadcaster in browser.xul scope
  var broadcaster = window.top.document.getElementById('searchEngineBroadcaster');     
  broadcaster.addEventListener("DOMAttrModified", onSearchEngineBroadcasterAttribChanged, false);    
  

	ClearAll();
	
	loadSearchSettings('fileTypeMenu');
	loadSearchSettings('fileSizeMenu');
	loadSearchSettings('fileSizeCustomRangeSelector');
	loadSearchSettings('file-size-custom-text');
	loadSearchSettings('fileDateMenu');
	loadSearchSettings('start-date-text');
	loadSearchSettings('end-date-text');
	loadSearchSettings('folderMenu');
	doLayout();
	
}


function isDesktopSearch (){
	return document.getElementById('searchBox').getAttribute('desktopSearch')? true:false;			
}

function isShowingAdvancedOptions (){
	return document.getElementById('searchBox').getAttribute('showingAdvanced')? true:false;		
}




/* Update the current text field from its observer 
 * @author: BC-Merc
 * @param: elemID, id of current element
 * 				 broadcasterID, id of broadcaster
 * @return: void
 * Note:  Make sure to update SearchPanelStartup() (loadSearchSettings() call) for any new fields
 */
function updateFieldFromObserver(elemID, broadcasterID) {
	debug("updateFieldFromObserver(" + elemID + ", " + broadcasterID + ");");
	//document.getElementById(elemID).setAttribute('value', document.getElementById(broadcasterID).getAttribute('value'));
	document.getElementById(elemID).value = document.getElementById(broadcasterID).getAttribute('value');
}

/* Save Search Settings Method
 * @author: BC-Merc
 * @param: id of current element
 * @return: void
 * Note:  Make sure to update SearchPanelStartup() (loadSearchSettings() call) for any new fields
 */
function saveSearchSettings(elemID) {
	
	debug("saveSearchSettings(" + elemID + ")");
	// Search Settings
	// Get preferences
  var prefServ = Components.classes["@mozilla.org/preferences-service;1"]
                             .getService(Components.interfaces.nsIPrefBranch);

	// Check if an item has a selectedIndex, else, get the value
	if (document.getElementById(elemID).selectedIndex != null) {	
		prefServ.setCharPref("browser.search."+elemID, document.getElementById(elemID).selectedIndex);
		debug("Element id: " + elemID + ", index: " + document.getElementById(elemID).selectedIndex);
	} else {
		//prefServ.setCharPref("browser.search."+elemID, document.getElementById(elemID).getAttribute('value'));
		prefServ.setCharPref("browser.search."+elemID, document.getElementById(elemID).value);
		debug("Element id: " + elemID + ", value: " + document.getElementById(elemID).value);
	}

}

/* Load Search Settings Method
 * @author: BC-Merc
 * @param: id of current element
 * @return: void
 * Note:  Make sure to update SearchPanelStartup() (loadSearchSettings() call) for any new fields
 */
function loadSearchSettings(elemID) {
	
	debug("loadSearchSettings(" + elemID + ")");
	// Search Settings
	// Get preferences
  var prefServ = Components.classes["@mozilla.org/preferences-service;1"]
                             .getService(Components.interfaces.nsIPrefBranch);

	// BC: saving the choice from this menu
	// Check if the pref has been set && the elemID exists, if so, copy to field
	if (prefServ.prefHasUserValue("browser.search." + elemID) && document.getElementById(elemID) != null) {
		loadedMenuPref = prefServ.getCharPref("browser.search." + elemID);
		
		// If the element has a selected index, set it, else set by value
		if (document.getElementById(elemID).selectedIndex != null) {
			document.getElementById(elemID).selectedIndex = loadedMenuPref;
		} else {
			document.getElementById(elemID).value = loadedMenuPref;
		}
	}
}

function doLayout(){
 // * Note:  Make sure to update SearchPanelStartup() (loadSearchSettings() call) for any new fields
	
	debug("doLayout()" );
	// File size selectors
	//var isDesktopSrch = isDesktopSearch();
	var isShowingAdvcedOptions = isShowingAdvancedOptions();



	
	// Get the availability of the Desktop Search
	var isDesktopSrch = desktopSearch.isDesktopSearchAvailable();
	// If the search is available, then show the advanced panel
	if (isDesktopSrch){
		//Add a showingAdvanced attribute to searchBox, the CSS will reveal the panel
		document.getElementById('searchBox').setAttribute('showingAdvanced', true);
		}
	
	
	var fileSizeMenu = document.getElementById('fileSizeMenu');	
	var selectedFileSizeOption = getMenuListSelectedValue('fileSizeMenu');	
	document.persist("fileSizeMenu", "value");
	debug("selectedFileSizeOption = " + selectedFileSizeOption );
	
	// Give custom box a default value of zero
	//document.getElementById('file-size-custom-text').value = 0;

	if (isDesktopSrch &&  isShowingAdvcedOptions && 
			(selectedFileSizeOption == VAL_FILE_SIZE_CUSTOM)) {
		debug("Showing fileCustomSizeBox" );
		document.getElementById('fileCustomSizeBox').hidden = false;}
	else {
		debug("Hiding fileCustomSizeBox" );
		document.getElementById('fileCustomSizeBox').hidden = true;
	}		

	//Date selections
	var selectedDateOption = getMenuListSelectedValue('fileDateMenu');
	var matchOrStartDateBox = document.getElementById('matchOrStartDateBox');
	var endDateBox = document.getElementById('endDateBox');

	
	debug("selectedDateOption =" + selectedDateOption);
	
	if (isDesktopSrch &&  isShowingAdvcedOptions && 
		 (selectedDateOption == VAL_FILE_DATE_BETWEEN || 
	 		selectedDateOption == VAL_FILE_DATE_BEFORE ||
	 		selectedDateOption == VAL_FILE_DATE_AFTER ||
	 		selectedDateOption == VAL_FILE_DATE_IS )){
				matchOrStartDateBox.hidden = false;
				debug("Showing matchOrStartDateBox" );
				
				if (selectedDateOption == VAL_FILE_DATE_BETWEEN) {
						endDateBox.hidden = false;
						debug("Showing endDateBox" );
				} else {
						endDateBox.hidden = true;
						debug("Hiding endDateBox" );
				}				
					
	} else {
		debug("Hiding matchOrStartDateBox" );
		matchOrStartDateBox.hidden = true;
		debug("Hiding endDateBox" );
		endDateBox.hidden = true;
	}	 	
	
}


// MERC (ccampbell)
/*	onSearchEngineBroadcasterAttribChanged
 *	Captures events from the toolbar search for processing within the sidebar
 * 	two events are of concern:
 *	searchText - with indicates the user's submission of search text
*/
function onSearchEngineBroadcasterAttribChanged(evt) {  
  
  debug("evt.attrName " + evt.attrName );  
  debug("evt.newValue " + evt.newValue );  
    
  // We are only going to react to changes to the 'searchengine' attribute  
  if ((evt.attrName != 'searchText') &&
  		(evt.attrName != 'searchStatus')){  			
  			return;
  }

	
  // JMC - Patching a strange little bug... window.top has no properties?
  if (!(window.top && window.top.document))
  	return;
  
  var broadcaster = window.top.document.getElementById('searchEngineBroadcaster');

 	if (evt.attrName == 'searchText') {
		document.getElementById("sidebar-search-text").value = broadcaster.getAttribute('searchText');
		
	}		
	
	// Monitor the state of the UI based on searchStatus
	if (evt.attrName == 'searchStatus') {			
		var searchStatus = evt.newValue;		
		if (searchStatus == 'started'){
			toggleSearchButtons(true);		
		} else {
			toggleSearchButtons(false);	
		}		
	}								 
}

function SearchPanelShutdown()
{
  /*
  var tree = document.getElementById("resultList");
  tree.database.RemoveObserver(RDF_observer);
  */
}


function toggleSearchButtons(isSearchActive)
{
	var searchButtonNode = document.getElementById("searchButton");
	var progressNode = parent.document.getElementById("statusbar-icon");
	searchButtonNode.disabled = false;
	
	if (isSearchActive) {
  
		// Get the stop button text
		if (!gStopButtonText){
			gStopButtonText = searchBundle.getString("stopButtonText");
		}
		
		searchButtonNode.setAttribute("stop", "true");
  	searchButtonNode.setAttribute("label", gStopButtonText);
  	searchButtonNode.setAttribute("oncommand", "doStop();");
  	document.getElementById("prgSearchProgress").hidden = false;
  	
				
	  if (progressNode){
	    progressNode.setAttribute("mode", "undetermined");
	  }
	  
	} else {

	  if (!gSearchButtonText){
	    gSearchButtonText = searchBundle.getString("searchButtonText");
	  }
  
  	searchButtonNode.removeAttribute("stop");
  	searchButtonNode.setAttribute("label", gSearchButtonText);
  	searchButtonNode.setAttribute("oncommand", "doSearch();");
  	document.getElementById("prgSearchProgress").hidden = true;

	  // should stop button press also stop the load of the page in the browser? I think so.  
	  if (progressNode){
	    progressNode.setAttribute("mode", "normal");
	  }	
	}
	     
}



function doStop()
{
	debug("function doStop()");

	/* Issue the Stop Curent Search Command.
	   Since Copernic can not actually be stopped from searching once started,
	   do not change the value of the search button to "Search" again, instead
	   switch to "Stopping" while Copernic Finishes.
	*/
	var searchButtonNode = document.getElementById("searchButton");
	//searchButtonNode.removeAttribute("stop");
  searchButtonNode.setAttribute("label", "Stopping...");
  searchButtonNode.removeAttribute("oncommand");
  searchButtonNode.disabled = true; 
      	
	desktopSearch.StopCurrentSearch();
	//toggleSearchButtons(false);
	
	// Notify desktop search observers that search has stopped
  var broadcaster = window.top.document.getElementById('searchEngineBroadcaster');
  broadcaster.setAttribute("searchStatus", 'stopped');

}

function doSearch()
{
	var sidebarSearchText = document.getElementById('sidebar-search-text').value;
	
	
	if (!desktopSearch.isDesktopSearchAvailable()) {
    var prefService = Components.classes['@mozilla.org/preferences-service;1']
       .getService(Components.interfaces.nsIPrefService)
       .getBranch(null);
	  var sDesktopSearchDownloadURL = prefService.getCharPref('sidebar.desktopsearch.url');
		getNavigatorWindow(true).loadURI( sDesktopSearchDownloadURL );
		return;
	}
	
  var navWindow = getNavigatorWindow(true);		
	navWindow.document.getAnonymousElementByAttribute( navWindow.document.getElementById('searchbar'), 'class', 'searchbar-textbox').value = sidebarSearchText;
	
  if (navWindow._content){  	  	
    onNavWindowLoad();
  }
  else {
    navWindow.addEventListener("load", onNavWindowLoad, false);
  }  
 
}

function ClearAll()
{
	selectMenuItemByValue("fileSizeMenu", VAL_ANY);
	selectMenuItemByValue("fileSizeCustomRangeSelector", VAL_FILE_SIZE_CUSTOM_AT_LEAST);	
	selectMenuItemByValue("fileDateMenu",VAL_ANY);
	selectMenuItemByValue("fileTypeMenu", VAL_ANY)
	selectMenuItemByValue("folderMenu","")
	document.getElementById("file-size-custom-text").value='0';	
	
	// Default the date to today
	var todayAsDate = new Date();
	var todayAsText = (todayAsDate.getUTCMonth()+ 1) + '/' + todayAsDate.getUTCDate()  + '/' + todayAsDate.getUTCFullYear();	
	document.getElementById("start-date-text").value= todayAsText;	
	document.getElementById("end-date-text").value= todayAsText;		
	
	doLayout();
	
}

function getUTCDateFromString(aDateString){
	
		var dateAsArray = aDateString.split('/');		
		var month = dateAsArray[0];
		var day = dateAsArray[1];
		var year = dateAsArray[2];
		return Date.UTC(year, month - 1, day); 
	
}

function getCorrectedYear(year) {
    year = year - 0;
    if (year < 70) return (2000 + year);
    if (year < 1900) return (1900 + year);
    return year;
}

function isValidateDate( strValue ) {
/************************************************
DESCRIPTION: Validates that a string contains only 
    valid dates with 2 digit month, 2 digit day, 
    4 digit year. Date separator can be ., -, or /.
    Uses combination of regular expressions and 
    string parsing to validate date.
    Ex. mm/dd/yyyy or mm-dd-yyyy or mm.dd.yyyy
    
PARAMETERS:
   strValue - String to be tested for validity
   
RETURNS:
   True if valid, otherwise false.
   
REMARKS:
   Avoids some of the limitations of the Date.parse()
   method such as the date separator character.
*************************************************/
  var objRegExp = /^\d{1,2}(\-|\/|\.)\d{1,2}\1\d{4}$/
 
  //check to see if in correct format
  if(!objRegExp.test(strValue))
    return false; //doesn't match pattern, bad date
  else{
    var arrayDate = strValue.split(RegExp.$1); //split date into month, day, year
	var intDay = parseInt(arrayDate[1],10); 
	var intYear = parseInt(arrayDate[2],10);
    var intMonth = parseInt(arrayDate[0],10);
	
	//check for valid month
	if(intMonth > 12 || intMonth < 1) {
		return false;
	}
	
    //create a lookup for months not equal to Feb.
    var arrayLookup = { '01' : 31,'03' : 31, '04' : 30,'05' : 31,'06' : 30,'07' : 31,
                        '08' : 31,'09' : 30,'10' : 31,'11' : 30,'12' : 31}
  
    //check if month value and day value agree
    if(arrayLookup[arrayDate[0]] != null) {
      if(intDay <= arrayLookup[arrayDate[0]] && intDay != 0)
        return true; //found in lookup table, good date
    }
		
    //check for February
	var booLeapYear = (intYear % 4 == 0 && (intYear % 100 != 0 || intYear % 400 == 0));
    if( ((booLeapYear && intDay <= 29) || (!booLeapYear && intDay <=28)) && intDay !=0)
      return true; //Feb. had valid number of days
  }
  return false; //any other values, bad date
}


function isAdvancedOptionsDataValid(){

	var promptTitle = "Desktop search";
	var promptMessage;
	var defaultPrompt = true;
	var isValid = true;
	
	debug('isAdvancedOptionsDataValid()');		
	var fileSizeFilter = getMenuListSelectedValue('fileSizeMenu');
	if (fileSizeFilter == VAL_FILE_SIZE_CUSTOM) {
		if (ForceNumber('file-size-custom-text', 'Specified size') == false){			
			promptMessage = searchBundle.getString("searchMsgInvalidSize"); 		
			isValid = false;	
		}
	}
			
	var selectedDateOption = getMenuListSelectedValue('fileDateMenu');
	if (isValid) {
		if ((selectedDateOption == VAL_FILE_DATE_BETWEEN) ||
				(selectedDateOption == VAL_FILE_DATE_BEFORE) ||	
				(selectedDateOption == VAL_FILE_DATE_AFTER) ||	
				(selectedDateOption == VAL_FILE_DATE_IS )){
					
				isValid = ForceDate('start-date-text');
				
				if ((selectedDateOption == VAL_FILE_DATE_BETWEEN) && isValid){
					isValid = ForceDate('end-date-text');
					// Between Date Validation
					startDate = getUTCDateFromString(document.getElementById('start-date-text').value);		 				
		  		endDate = getUTCDateFromString(document.getElementById('end-date-text').value);
		  		if(startDate > endDate){
		  			isValid = false;
		  			defaultPrompt = false;
		  			promptMessage = searchBundle.getString("searchMsgInvalidBetweenDates");
		  			}
  				// If the startDate is less than the endDate then ensure the dates are not equal
  				if (isValid) {
  					if(startDate == endDate){
	  					isValid = false;
	  					defaultPrompt = false;
	  					promptMessage = searchBundle.getString("searchMsgEqualBetweenDates");
	  					}
  					}	
					}
				
				if (!isValid && defaultPrompt) promptMessage = searchBundle.getString("searchMsgInvalidDates");										
			}				
	}			
	
	
	if (isValid) {  	
		if (ForceValidFilePath('folderMenu', getMenuListSelectedValue('folderMenu'), 'Folder path') == false){		  					
			promptMessage = searchBundle.getString("searchMsgInvalidFolderPath");										
			isValid = false;													
		}
	}
	
	if (!isValid) {
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
	              getService(Components.interfaces.nsIPromptService);
		prompts.alert(window, searchBundle.getString("searchPromptTitle"), promptMessage);
	
	}

						
	return isValid;	
					
}



function ForceNumber(targetFieldID)
{
	var targetField = document.getElementById(targetFieldID);
	var strField = new String(targetField.value);
	
	if (isWhitespace(strField)) return true;

	var i = 0;

	for (i = 0; i < strField.length; i++)
		if (strField.charAt(i) < '0' || strField.charAt(i) > '9') {			
			targetField.focus();
			if (targetField['select']){
				targetField.select();
			}
			return false;
		}

	return true;
}

function ForceDate(targetFieldID)
{
	var targetField = document.getElementById(targetFieldID);
	var strField = new String(targetField.value);
	
	if (isWhitespace(strField)) return true;

	if (!isValidateDate(strField)){
			targetField.focus();
			if (targetField['select']){
				targetField.select();
			}
			return false;
	}

	return true;
}

 
function launchFile(path){
	debug('launchFile(' + path + ')');					
	try {
		var file = Components.classes["@mozilla.org/file/local;1"]
	                     .createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(path);
		file.launch();
				
	}catch(e){
		debug('There was a problem opening the file.');		
		throw e;
		return false;
	}		
	return true;	
}

function isValidFolder(path){
	debug('isValidFolder(' + path + ')');				
	try {
		var file = Components.classes["@mozilla.org/file/local;1"]
		                     .createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(path);
		file.isDirectory()
	} catch (e) { 
		debug('Invalid folder path!');
		return false;		
	}	
	return true;
	
}
	
function ForceValidFilePath(targetFieldID, targetValue)
{
	var targetField = document.getElementById(targetFieldID);
	if (targetValue) {
		var strField = new String(targetValue);
	} else {
		var strField = new String(targetField.value);	
	}	
	
	if (isWhitespace(strField)) return true;

	if (!isValidFolder(strField)){		
			targetField.focus();
			if (targetField['select']){
				targetField.select();
			}
		return false;		
	}
	
	return true;
	
}

/****************************************************************/

// Check whether string s is empty.

function isEmpty(s)
{   return ((s == null) || (s.length == 0))
}

/****************************************************************/

// Returns true if string s is empty or 
// whitespace characters only.

function isWhitespace (s)

{   var i;

    // Is s empty?
    if (isEmpty(s)) return true;

    // Search through string's characters one by one
    // until we find a non-whitespace character.
    // When we do, return false; if we don't, return true.

    for (i = 0; i < s.length; i++)
    {   
	// Check that current character isn't whitespace.
	var c = s.charAt(i);

	if (whitespace.indexOf(c) == -1) return false;
    }

    // All characters are whitespace.
    return true;
}
 


function showAdvancedPanel(){
	document.getElementById('searchBox').setAttribute('showingAdvanced', true);
	doLayout();		
}

function hideAdvancedPanel(){
	document.getElementById('searchBox').removeAttribute('showingAdvanced');
	doLayout();		
}


function performDesktopSearch(searchText){
	
	debug('performDesktopSearch(' + searchText + ')');
	  
  try {		 
						 					  			  	  			  	
		if (!isAdvancedOptionsDataValid()) {	  				  			
				showAdvancedPanel();
			 	return;
		}				
		
		// Notify desktop search observers that search has started
	  var broadcaster = window.top.document.getElementById('searchEngineBroadcaster');
  	broadcaster.setAttribute("searchStatus", 'started');		

		desktopSearch.ClearFilters();	
		
		// The following if structure ensures that if the desktopSearch.ExecuteSearch
		// does not return true, i.e. a search error occures, we never enter the 		
	  desktopSearch.ExecuteSearch(searchText, displayResults);
	  
  	
	}
	catch (e){				
		logError(e,'Desktop search error.');											
		return;
	}
	
}	

function displayResults() {
	debug('displayResults()');
		  				  
	try {	  			  
					  			  	  			    			  	  			  				  	
		/*===================================================
			File type
		===================================================*/			  			  	
		var fileTypeFilter = getMenuListSelectedValue('fileTypeMenu');
		if(fileTypeFilter && fileTypeFilter != VAL_ANY){
			desktopSearch.FilterFileType(fileTypeFilter);		  		
		}					
		  
		/*===================================================
			File size
		===================================================*/			  	
		var fileSizeFilter = getMenuListSelectedValue('fileSizeMenu');
		if(fileSizeFilter && (fileSizeFilter != VAL_ANY)){
			if (fileSizeFilter == VAL_FILE_SIZE_SMALL) {
					desktopSearch.FilterSizeLessThan(100000);
			}else if (fileSizeFilter == VAL_FILE_SIZE_MED) {
					desktopSearch.FilterSizeBetween(100000,1024000);
			}else if (fileSizeFilter == VAL_FILE_SIZE_LG) {
					desktopSearch.FilterSizeGreaterThan(1024000);
			}else if (fileSizeFilter == VAL_FILE_SIZE_CUSTOM) {
				
				var fileSizeCustom = 0; 
				fileSizeCustom = document.getElementById('file-size-custom-text').value;
				var fileRangeSelector = getMenuListSelectedValue('fileSizeCustomRangeSelector');
				if (!fileSizeCustom) {fileSizeCustom = 0};
				var fileSizeCustomBytes = fileSizeCustom * 1000;		
				if (fileRangeSelector == VAL_FILE_SIZE_CUSTOM_AT_LEAST){						  	
						desktopSearch.FilterSizeGreaterThan(fileSizeCustomBytes -1);		  					
				}else if (fileRangeSelector == VAL_FILE_SIZE_CUSTOM_AT_MOST){
					desktopSearch.FilterSizeLessThan(fileSizeCustomBytes + 1);		  							  				
				}
			}		  						  		  				  		
		}					
		
		
		/*===================================================
			Date qualifiers
		===================================================*/			  		  	
		var selectedDateOption = getMenuListSelectedValue('fileDateMenu');
		
		if (selectedDateOption != VAL_ANY){
		
	  	var startDate;
	  	var endDate;
	  	var temp = new Date(); 
	  	var today = Date.UTC(temp.getFullYear(),temp.getMonth(),temp.getDate()); 
	  		  		  		  		  		  		  		  		  		  	
	  	switch (selectedDateOption)
	  	{
	  		case VAL_FILE_DATE_TODAY:			  				   			  			
	  			startDate = today;
	  			desktopSearch.FilterDateOn(startDate);
	  			break;		
	  		case VAL_FILE_DATE_YSTRDAY:	  			
	  			startDate = today - 86400000;	  			  			
	  			desktopSearch.FilterDateOn(startDate);
	  			break;	
	  		case VAL_FILE_DATE_THIS_WEEK:	  			  			
	  			startDate = ((today - (temp.getUTCDay() * 86400000))- 86400000);	
	  			endDate = today; 	  			
	  			desktopSearch.FilterDateAfter(startDate);
	  			break;		  			
	  		case VAL_FILE_DATE_THIS_MONTH:
	  			startDate = (Date.UTC(temp.getUTCFullYear(), temp.getUTCMonth(), 1) - 86400000);
	  			endDate = today;
	  			desktopSearch.FilterDateAfter(startDate);
	  			break;
	  		case VAL_FILE_DATE_THIS_YEAR:
	  			startDate = (Date.UTC(temp.getUTCFullYear(), 0, 1 )- 86400000);
	  			endDate = today;
	  			desktopSearch.FilterDateAfter(startDate);
	  			break;
	  		case VAL_FILE_DATE_BETWEEN:
		  		startDate = getUTCDateFromString(document.getElementById('start-date-text').value);		 				
		  		endDate = getUTCDateFromString(document.getElementById('end-date-text').value);		 																				
		  		desktopSearch.FilterDateBetween(startDate, endDate);						  		
		  		break;	
	  		case VAL_FILE_DATE_BEFORE:
		  		startDate = getUTCDateFromString(document.getElementById('start-date-text').value);		 				
		  		desktopSearch.FilterDateBefore (startDate);
		  		break;	
	  		case VAL_FILE_DATE_AFTER:
		  		startDate = getUTCDateFromString(document.getElementById('start-date-text').value);		 				
		  		desktopSearch.FilterDateAfter(startDate);
		  		break;	
	  		case VAL_FILE_DATE_IS:
		  		startDate = getUTCDateFromString(document.getElementById('start-date-text').value);		 				
		  		desktopSearch.FilterDateOn(startDate);
	  			break;		  				  		
			}
		}
	  	 		  	 		  
		var folderPath = getMenuListSelectedValue('folderMenu');
		if(folderPath){
			desktopSearch.FilterPath(folderPath);		  		
		}		
						  														  			  	  			  	
		var resultsDoc = desktopSearch.RetrieveResults();				  	
		var resultsCount = desktopSearch.GetSearchInfo(resultsDoc, 'count');			  			  	
	
		if (resultsCount> 0){	 
			var resultsPagePath = desktopSearch.CreateResultsPage(resultsDoc);
			loadURLInContent(resultsPagePath);
			
		}
  	else {		 
  			
			var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
										getService(Components.interfaces.nsIPromptService);			
			prompts.alert(window, searchBundle.getString("searchPromptTitle"), 
														searchBundle.getString("searchMsgnoMatchingResults"));
			  		    
  	}		  	  		  			    	    			  	
	}
	catch (e){				
		logError(e,'Desktop search error.');											
		return;
	}					
	
	// Notify desktop search observers that search has completed
  var broadcaster = window.top.document.getElementById('searchEngineBroadcaster');
 	broadcaster.setAttribute("searchStatus", 'complete');		

}

function isDesktopSearch(){
		return true;	
	//return document.getElementById("basicEngineMenu").selectedItem.id == 'DesktopSearch';
	
}

// MERC - Stevo : Only called when user clicks on "Search" button on sidebar.
function onNavWindowLoad() {
	
	debug('function onNavWindowLoad()');
  
	var searchText = getMenuListSelectedValue("sidebar-search-text");  
  
	// Add the search text to the file that stores the search history
	if (searchText) AddToHistory(searchText, SEARCH_HISTORY_FILE );
	
	// Note: desktop searches do not require search text
	performDesktopSearch(searchText);  		

	}	
									
	function GetElementText(local, parentElem) {
    var result = parentElem.getElementsByTagName(local)[0];
    if (result) {
        return result.firstChild.nodeValue;            
    } else {
        return "n/a";
    }
	}
	
function saveSearch()
{
  var ds = document.getElementById("resultList").database;
  if (!ds){
    return;
  }

  var lastSearchURI = "";
  var lastSearchText = "";

  var rdf = Components.classes[RDFSERVICE_CONTRACTID].getService(nsIRDFService);
  // look for last search URI
  var source = rdf.GetResource("NC:LastSearchRoot", true);
  var childProperty = rdf.GetResource("http://home.netscape.com/NC-rdf#ref", true);
  var target = ds.GetTarget(source, childProperty, true);
  if (target) {
    target = target.QueryInterface(nsIRDFLiteral).Value;
    if (target){
      lastSearchURI = target;
    }
  }

  // look for last search text
  childProperty = rdf.GetResource("http://home.netscape.com/NC-rdf#LastText", true);
  target = ds.GetTarget(source, childProperty, true);
  if (target) {
    target = target.QueryInterface(nsIRDFLiteral).Value;
    if (target) {
      // convert plusses (+) back to spaces      
      target = target.replace(/\+/g, " ");
      lastSearchText = decodeURIComponent(target);
    }
  }

  if (!lastSearchURI){
    return;
  }

  // rjc says: if lastSearchText is empty/null, that's still OK, synthesize the text
  if (!lastSearchText) {
    lastSearchText = lastSearchURI;
    var siteOffset = lastSearchText.indexOf("://");
    if (siteOffset > 0) {
      siteOffset += 3;
      var endOffset = lastSearchText.indexOf("/", siteOffset);
      if (endOffset > 0){
        lastSearchText = lastSearchText.substr(0, endOffset+1);
      }
    }
  }

  var searchTitle = searchBundle.stringBundle.formatStringFromName(
                      "searchTitle", [lastSearchText], 1);

  var bmks = Components.classes[BMARKS_CONTRACTID].getService(nsIBookmarksService);
  bmks.addBookmarkImmediately(lastSearchURI, searchTitle, bmks.BOOKMARK_SEARCH_TYPE, null);
}



function loadURLInContent(url, reUseTab)
{ 
	debug('loadURLInContent(' + url + ',' + reUseTab + ')');
  if (reUseTab) {
  	debug('loadURLInContent:Reusing tab');
  	getNavigatorWindow(true).SearchLoadURL(url, null, true);
  } else {
  	getNavigatorWindow(true).SearchLoadURL(url);
  } 
}

function search_getBrowserURL()
{
  return nsPreferences.copyUnicharPref("browser.chromeURL", "chrome://browser/content/browser.xul");
}


//Step up the dom until getting the desired node.
function getItemNode(aNode,nodeName)
{
  var node = aNode;
  while (node.localName != nodeName) {
    node = node.parentNode;
  }
  return node ? node : null;
}

function getArcValueForID(aArc, aID)
{
  var val = null;

  try
  {
    var ds = document.getElementById("resultList").database;
    if (ds)
    {
      var rdf = Components.classes[RDFSERVICE_CONTRACTID].
                  getService(nsIRDFService);
      var src = rdf.GetResource(aID, true);
      var prop = rdf.GetResource(
                  "http://home.netscape.com/NC-rdf#"+aArc, true);
      val = ds.GetTarget(src, prop, true);        
      if (val){
        val = val.QueryInterface(nsIRDFLiteral).Value;
      }
    }
  } 
  catch (ex)
  {
    dump("Exception: no value for " + aArc + "!\t" + ex + "\n");
    val = null;
  }

  return val;
}

function FillInDescTooltipDesktopSearch(tipElement)
{	
	var tt = tipElement;
	debug('FillInDescTooltipDesktopSearch(' + tipElement.id + ')');
  var retValue = false;
  
  //Get the Name of the listitem for first item in the tooltip
  //var nodeLabel = tipElement.getAttribute("label");
  //var nodeID = tipElement.id;
  
  var tooltipvalues = tipElement.getAttribute('tooltipvalues').split('|');
  document.getElementById('fileNameTipText').setAttribute('value',tooltipvalues[0]);  
  document.getElementById('fileTypeTipText').setAttribute('value',tooltipvalues[1]);  
  document.getElementById('fileSizeTipText').setAttribute('value',tooltipvalues[2]);  
  document.getElementById('fileDateTipText').setAttribute('value',tooltipvalues[3]);  
  document.getElementById('fileFolderTipText').setAttribute('value',tooltipvalues[4]);  
                    
 	retValue = true;
 	  
  return retValue;
  
}

//Fill in tooltip in teh search results panel
function FillInDescTooltip(tipElement)
{
  var retValue = false;
 
  //Get the Name of the listitem for first item in the tooltip
  var nodeLabel = tipElement.getAttribute("label");
  var nodeID = tipElement.id;
 
  //Query RDF to get URL of listitem
  if (nodeID){
    var url = getArcValueForID("URL", nodeID);
  }

  //Fill in the the text nodes
  //collapse them if there is not a node
  if (nodeLabel || url) {
    var tooltipTitle = document.getElementById("titleText");
    var tooltipUrl = document.getElementById("urlText"); 
    if (nodeLabel) {
      if (tooltipTitle.getAttribute("hidden") == "true"){
				tooltipTitle.removeAttribute("hidden");
       }
      tooltipTitle.setAttribute("value",nodeLabel);
    } 
    else  {
      tooltipTitle.setAttribute("hidden", "true");
    }
    if (url) {
      if (tooltipUrl.getAttribute("hidden") == "true"){
        tooltipUrl.removeAttribute("hidden");
      }
      if (url.length > 100){
        url = url.substr(0,100) + "...";
      }
      tooltipUrl.setAttribute("value",url);
    }
    else {
      tooltipUrl.setAttribute("hidden", "true");
    }
    retValue = true;
  }
  return retValue;
}

	function logError(exceptionObject, optionalAdditionalText) {	
	// logs (or otherwise handles) errors
    // do logging ?!
    // for now, just alert
    var output;
    var errSource = logError.caller;    //Source function from the error

    output = "Function: " + errSource.name ;

    if (errSource.arity > 0){
        output +=    "\nArguments: \n"
        for (i=0; i < errSource.arity; i++){
            output += "   (" + i + ") " + errSource.arguments[i] ;
        }
    }
    output += "\nException: " + exceptionObject.message ;

    if (optionalAdditionalText != null) {
        output += "\nNotes: " + optionalAdditionalText;
    }
    debug("\n" + output);       
   
}


var nsResultDNDObserver = 
{
  onDragStart: function(aEvent, aXferData, aDragAction)
  {
    var node = getItemNode(aEvent.target, "listitem");
    var URL = getArcValueForID("URL", node.id);
    var title = getArcValueForID("Name", node.id);
    var htmlString = "<a href=\"" + URL + "\">" + title + "</a>";
    var urlString = URL + "\n" + title;

    aXferData.data = new TransferData();
    aXferData.data.addDataForFlavour("text/x-moz-url", URL);
    aXferData.data.addDataForFlavour("text/unicode", urlString);
    aXferData.data.addDataForFlavour("text/html", htmlString); 
  }
};


