var threatsQueue = {
	
	mCurrentThreat: null,
	mCycleInterval: null,
	mThreats: null,
	mNumThreats: null,
	mTimer: null,
		
	init : function() {
		// initialize the queue's member variables
		this.mCurrentIndex = 0;
		this.mCycleInterval = 5000;
		this.mThreats = Array(9);
		this.mNumThreats = 0;
		 
		this.makeTimer(this.mCycleInterval);

	},
	
	/* adds a threat to the threats queue */
	add : function(aThreat, aThreatType) {		
		// sanity check
		if (!this.mThreats) {
			return;	
		}
		
		// only add to the queue if this threat is not there already
		// to avoid duplicates
		if (this.mThreats[aThreat] == null) {
				this.mThreats[aThreat] = aThreatType;
				//dump('\n\n\nadding threat to array: ' + aThreat + '\n\n\n');
				this.mNumThreats++;
		}
									
	},
	
	remove : function(aThreatIndex) {
			if (!this.mThreats)
				return;
			if (this.mThreats[aThreatIndex] == null)
				return;
			else {
				//dump('removing threat of index: ' + aThreatIndex);
				this.mThreats[aThreatIndex] = null;
				this.mNumThreats--; 				
			}
	},
	
	/* cycles through the threats UI for the security dashboard*/
	cycle : function() {
		// start at the last queue index position 
		if (dashboard == null) {
			this.mTimer.cancel();
			return;
		}
		
		//this.dump_queue();
		
		// start at the last index
		while (this.mCurrentIndex < this.mThreats.length) {
			// found a security threat
			if (this.mThreats[this.mCurrentIndex] == "yellow" || this.mThreats[this.mCurrentIndex] == "red") {
				// flip the status bar panel to the next threat
				dashboard.flipStatusbarPanelStatus(this.mCurrentIndex);		
				// next time start with the next potential threat of the queue				
				this.mCurrentIndex++;
				return;
			} 
			this.mCurrentIndex++;
		}
		
				// reset to the top of the queue if we're at the queue length
		if (this.mCurrentIndex >= (this.mThreats.length) ) {
			this.mCurrentIndex = 0;
		}
		
		return;		
		
	},
	
	hasRedThreats: function() {
		for (var i=0; i < this.mThreats.length; i++) {
			if (this.mThreats[i] == "red")
				return true;
		}
		
		return false;
	},
	
	hasYellowThreats: function() {
		for (var i=0; i < this.mThreats.length; i++) {
			if (this.mThreats[i] == "yellow")
				return true;
		}
		
		return false;
	},
	
	
  makeTimer: function(aDelay)
  {
    if (!this.mTimer)
      this.mTimer = Components.classes["@mozilla.org/timer;1"]
                              .createInstance(Components.interfaces.nsITimer);
    this.mTimer.cancel();
    this.mTimer.initWithCallback(this, aDelay,
                                 Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
  },
	
	notify: function(aTimer) {
		this.cycle();
	},
	
	dump_queue: function() {
		for (var i=0; i < this.mThreats.length; i++)
			dump('queue position: ' + i + ': ' + this.mThreats[i] + '\n');
	},
	
}