var sitecontrols;
if (!sitecontrols) {

sitecontrols = {

	// Set to true to enable debug output
	DEBUG : false,
	
	SPECIAL_SITES: new Array('Verified Default',
													'Not Verified Default', 
													'Warning Default',
													'Local Files'),

	SC_NS : "http://home.netscape.com/SC-rdf#",
	NC_NS : "http://home.netscape.com/NC-rdf#",
	WEB_NS : "http://home.netscape.com/WEB-rdf#",
	RDF_NS : "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	XUL_NS : "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
	NC_NS_CMD : null,

	SC_VERIFIED_DEFAULT		:	"SiteControls:VerifiedDefault",
	SC_NOT_VERIFIED_DEFAULT	:	"SiteControls:NotVerifiedDefault",
	SC_WARNING_DEFAULT		:	"SiteControls:WarningDefault",
	SC_LOCAL				:	"SiteControls:Local",
	DEFAULT_URI				:	"SiteControls:Default",
	DEFAULT_SITE			:	"Default",
	defaults				:	 null,

	// definition of the services frequently used for site controls
	kRDFContractID : "@mozilla.org/rdf/rdf-service;1",
	kRDFSVCIID : Components.interfaces.nsIRDFService,
	kRDFRSCIID : Components.interfaces.nsIRDFResource,
	kRDFLITIID : Components.interfaces.nsIRDFLiteral,
	kRDFDSIID : Components.interfaces.nsIRDFDataSource,
	RDF : null,

	kRDFCContractID : "@mozilla.org/rdf/container;1",
	kRDFCIID :  Components.interfaces.nsIRDFContainer,
	RDFC : null,

	kRDFCUContractID : "@mozilla.org/rdf/container-utils;1",
	kRDFCUIID : Components.interfaces.nsIRDFContainerUtils,
	RDFCU : null,

	kPREFContractID : "@mozilla.org/preferences-service;1",
	kPREFIID : Components.interfaces.nsIPrefService,
	kPBIID : Components.interfaces.nsIPrefBranch,
	PREF : null,

	kSOUNDContractID : "@mozilla.org/sound;1",
	kSOUNDIID : Components.interfaces.nsISound,
	SOUND : null,

	kWINDOWContractID : "@mozilla.org/appshell/window-mediator;1",
	kWINDOWIID : Components.interfaces.nsIWindowMediator,
	WINDOWSVC : null,

	kDSContractID : "@mozilla.org/widget/dragservice;1",
	kDSIID : Components.interfaces.nsIDragService,
	DS : null,

	kSCContractID : "@mozilla.org/browser/sitecontrols-service;1",
	kSCSVCIID : Components.interfaces.nsISiteControlsService,
	SCSVC : null,
	SCDS : null,


	initServices : function() {
		this.debug('initServices()');
		if (!this.SCDS) {
			this.NS_NS_CMD = this.NC_NS + "command?cmd=";
			this.RDF       = Components.classes[this.kRDFContractID].getService(this.kRDFSVCIID);
			this.RDFC      = Components.classes[this.kRDFCContractID].createInstance(this.kRDFCIID);
			this.RDFCU     = Components.classes[this.kRDFCUContractID].getService(this.kRDFCUIID);
			this.PREF      = Components.classes[this.kPREFContractID].getService(this.kPBIID);
			this.SOUND     = Components.classes[this.kSOUNDContractID].createInstance(this.kSOUNDIID);
			this.WINDOWSVC = Components.classes[this.kWINDOWContractID].getService(this.kWINDOWIID);
			this.DS        = Components.classes[this.kDSContractID].getService(this.kDSIID);
			this.SCSVC     = Components.classes[this.kSCContractID].getService(this.kSCSVCIID);
			this.SCDS      = this.SCSVC.QueryInterface(this.kRDFDSIID);
						
		}
	},

	
	notifyUser : function(actionType) {
		if (!this.promptService)
			this.promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);

		if (this.PREF.getBoolPref("browser.sitecontrols.notify." + actionType)) {

			var promptTitle;
			var promptMsg;
			switch (actionType) {

				case "switch_to_ie" :
					promptTitle = "Vulnerability Warning";
					promptMsg = "You have chosen to view this web site using the Internet Explorer display engine. Your setting will be remembered the next time you visit this site.";
					break;

				case "enable_activex" :
					promptTitle = "Vulnerability Warning";
					promptMsg = "You have chosen to enable ActiveX on this web site. Your setting will be remembered the next time you visit this site. Please be aware that there are known security vulnerabilities with ActiveX.";
					break;

				case "enable_vbscript" :
					promptTitle = "Vulnerability Warning";
					promptMsg = "You have chosen to enable VB Script on this web site. Your setting will be remembered the next time you visit this site. Please be aware that there are known security vulnerabilities with VB Script.";
					break;

				case "disable_javascript" :
					promptTitle = "Compatibility Warning";
					promptMsg = "You have chosen to disable javascript on this web site. Your setting will be remembered the next time you visit this site. Please be aware that many web sites will not display correctly without javascript turned on.";
					break;

				case "disable_cookies" :
					promptTitle = "Compatibility Warning";
					promptMsg = "You have chosen to disable cookies on this web site. Your setting will be remembered the next time you visit this site. Please be aware that many web sites will not display correctly without cookies turned on.";
					break;


			}
			var checkResult = {};
			checkResult.value = true;

			var flags = this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_0 +
									this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_1 +
									this.promptService.BUTTON_POS_1_DEFAULT;
			       //   promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1 +
          				

			var result = this.promptService.confirmEx(window, promptTitle,
					promptMsg, flags, "Open Site Controls Options", "OK", null, "Don't show this message again",  checkResult);

			if (checkResult.value)
				this.PREF.setBoolPref("browser.sitecontrols.notify." + actionType, false);

			dump('**** result value: ' + result + '\n');
			if (!result)
				openSiteControlPrefs();
		}

	},
	
	getSiteRootDomainResByTitle : function(title) {
				
		var root = this.getSiteRootDomain(title);												
		root = sitecontrols.RDF.GetLiteral(root);					
		return this.SCDS.GetSource(SC_TITLE, root, true);	

	},
	
	getSiteRootDomain : function(aDomain) {																	
			this.debug('getSiteRootDomain(' + aDomain + ')');											
	    try {
      		var delimited = aDomain.split('.');
      		return delimited[delimited.length - 2] + '.' + delimited[delimited.length -1];        			     
			} catch (ex) {
				return null;
			}				
	},
				
	ensureValidDatasource : function(ds) {		
		
		// Iterate throught the datasource and create root domain entries for any
		// sites that do not have one
		this.debug('ensureValidDatasource()');												
		var arcs = ds.GetAllResources;    		
		var createList = new Array();								
		var arcs = ds.GetAllResources();  
		
		while (arcs.hasMoreElements()) { 	  			    						
			var site = arcs.getNext().QueryInterface(Components.interfaces.nsIRDFResource);    					            									
      if (!ds.GetTarget(site, SC_TITLE,true)) continue; //ignore items that don't have a title property      						            
			var title = ds.GetTarget(site, SC_TITLE,true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;                            												
			if (!title) continue; // no title no go						
			if (this.indexOf(this.SPECIAL_SITES, title) > -1) continue //on ignore list no go; 			
			var rootDomain = this.getSiteRootDomain(title);							
			var found = this.indexOf(createList, rootDomain); 
			if (found > - 1) continue; //found so leave it
			if (title == rootDomain) continue; // this resource is the root domain			
			createList.push(rootDomain);												
		}	
				
		for (var i=0;i!=createList.length;i++){		
			this.debug('Adding root: ' + createList[i] );		
			this.SCSVC.addControlledSite(createList[i]);								
		}							 
		 
	},

	SetFilterAssert : function(res, aInclude) {		

		var ds = sitecontrols.RDF.GetDataSource("rdf:sitecontrols");
		
		// Get the current value of the SC_FILTER_INCLUDE assertion
		// We do this so that we can unassert the specific arc
		// and then assert a new one based on the whether the 
		// resource satisfies the filter							
		var currentSetting = ds.GetTarget(res, SC_FILTER_INCLUDE,true);
											
		//Unassert the current value
		if (currentSetting){						
				currentSetting = currentSetting.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
				ds.Unassert(res, 
				SC_FILTER_INCLUDE, 
				sitecontrols.RDF.GetLiteral(currentSetting), 						
				true);						
		}
		
		ds.Assert(res, 
		SC_FILTER_INCLUDE, 
		sitecontrols.RDF.GetLiteral(aInclude), 						
		true);		
				
	},
	
	indexOf : function(targetArray, key) {		
	
		for (index in targetArray){
	       if (targetArray[index] == key){
	            return index;
	            }
	        }
	       return -1;    
	
	},

	AssembleFormattedSiteListRDF : function(aFilter) {		
		
		this.debug('AssembleFormattedSiteListRDF()');										
						
		var ds = sitecontrols.RDF.GetDataSource("rdf:sitecontrols");				
		this.ensureValidDatasource(ds);																											
	

		var domainGroups = new Array();
		var displayDomains = new Array();												
        
		var arcs = ds.GetAllResources();    
				
		while (arcs.hasMoreElements()) {    	      
            
      var site = arcs.getNext().QueryInterface(Components.interfaces.nsIRDFResource);               	
      if (!ds.GetTarget(site, SC_TITLE,true))  continue; //ignore items that don't have a title property
            
      var title = ds.GetTarget(site, SC_TITLE,true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;                            
      			            			
      if (this.indexOf(this.SPECIAL_SITES, title) > -1) continue; // Don't process ignored items			                 
      var rootDomain = this.getSiteRootDomain(title); //Assemble the root domain for the current site                       			
      var found = this.indexOf(domainGroups, rootDomain);	  // root domains processed thus far         
     
     	// Build up a 2 dimensional array of domains (site resources)     			                         
      if (found > -1) {         	      	       																					      																					      	      	
      		if (title == rootDomain) {   
      			//If this the root then make it the first item in the array   			
      			displayDomains[found].unshift(site)
      		} else {
      			displayDomains[found].push(site);       	      	      	      		
      		}      			
      		      	         	   	
     	} else {        			         		 		     		 	
	     		// Add the root domain to our list of root domains
	      	found = domainGroups.push(rootDomain);   	 	      	     	  	        	      		      	
	      	displayDomains[found - 1] = new Array(site);          		      	
      }      
    }    
   	   	   	
   	ds.beginUpdateBatch ();	
   	
   	// Add a new sequence resource to the datasource
   	// This sequence will contain the hierarchy of
   	// the sites as determined by their domain
		var seqNode = sitecontrols.RDF.GetResource("http://home.netscape.com/SC-rdf/formattedSites");					
		sitecontrols.RDFCU.MakeSeq(ds, seqNode);
		
		var rootContainer = Components.classes['@mozilla.org/rdf/container;1'].createInstance()
																			.QueryInterface(Components.interfaces.nsIRDFContainer);		
		rootContainer.Init(ds, seqNode);		
		
		// Purge existing items from the sequence if they exist
		var children = rootContainer.GetElements();
		while (children.hasMoreElements()){
			var child = children.getNext();			
			if (sitecontrols.RDFCU.IsContainer(ds,child)){
				var subContainer = Components.classes['@mozilla.org/rdf/container;1'].createInstance();
				subContainer = subContainer.QueryInterface(Components.interfaces.nsIRDFContainer);		
				subContainer.Init(ds, child);					
				var gchildren = subContainer.GetElements();
				while (gchildren.hasMoreElements()){
					var gchild = gchildren.getNext();							
						subContainer.RemoveElement( gchild , false)					
				}				
			}
			if (child instanceof Components.interfaces.nsIRDFResource){
				rootContainer.RemoveElement( child , false)
			}					
		}
		
		// Assemble formattedSites sequence in such a way that it reflects the
		// domain / subdomain relationships
		// Also create a property on each resource which will be the display value
		// in the site controls tree
		// Note: 
		// The first element in the displayDomains array is always the root domain
		// and is created as a sequence which will contain references to the subsequent
		// nodes in the array. These subsequent nodes represent sites that are sub-domains
    for (var i = 0; i < displayDomains.length; ++ i) {    	   	
 																						      		      		     																		    									
			for (var j = 0; j < displayDomains[i].length; ++ j) {    	   	    																		    																    	
				
				var isSubDomain = j > 0; // if the index is greater than 1 then we are processing a subdomain	
				var res = displayDomains[i][j];				
				var resTitle = ds.GetTarget(res, SC_TITLE,true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;		
				
				if (!aFilter || resTitle.indexOf(aFilter) != -1){										
					dump('Matched filter:' + resTitle + '\n')
					this.SetFilterAssert(res, 'true');
					// if the subdomain was good then make the root good too
					if (isSubDomain) this.SetFilterAssert(displayDomains[i][0], 'true');
				} else {
					dump('Failed filter:' + resTitle + '\n')
					this.SetFilterAssert(res, 'false') 						
				}					
							
				if (j===0){
					
						// Process a root domain					
						var rootTitle = resTitle; 					                          													    																
			  		var displayAs = resTitle;			  		
			  		
			  		//Append the domain to the root of the formattedSites container 
		  			rootContainer.AppendElement(res);     							
						sitecontrols.RDFCU.MakeSeq(ds,res);
						var RDFCSubDomains = Components.classes['@mozilla.org/rdf/container;1'].createInstance(); //Create the container for the subdomains
						RDFCSubDomains = RDFCSubDomains.QueryInterface(Components.interfaces.nsIRDFContainer);					
						RDFCSubDomains.Init(ds,res); // Initialize the new container
				
			  } else {
			  	
			  	// Process a sub-domain
			  	var displayAs = resTitle.replace(rootTitle,'');										
					if (displayAs.substr(-1,1) == '.'){						
						displayAs = displayAs.substring(0,displayAs.lastIndexOf('.'));						
					}	
					
					//Append the sub-domain to its root domain container
					RDFCSubDomains.AppendElement(res);		
			  }
			  
			  // Set the display value for the tree if it hasn't been set already				  					  					  					  		
	  		var hasDisplay = ds.hasArcOut(res, SC_DISPLAY);			  					  									  					  		
				if (!hasDisplay){
					ds.Assert(res, 
					SC_DISPLAY, 
					sitecontrols.RDF.GetLiteral(displayAs), 						
					true);	
				}			  																								
			}																																																								
		}		
				
		ds.endUpdateBatch();									
	},
	
	removeSite : function(site) {
		
		
			var container = Components.classes["@mozilla.org/rdf/container;1"].
                  createInstance(Components.interfaces.nsIRDFContainer);
			
			/*===================================================
				Remove any subdomains
			===================================================*/																	
			try {
			  container.Init(sitecontrols.SCDS, site);
			  var children = container.GetElements();
			  while (children.hasMoreElements()){
					var child = children.getNext();
					var titleProp = sitecontrols.RDF.GetResource(sitecontrols.SC_NS+'title');
      		var titleRes = sitecontrols.SCDS.GetTarget(child, titleProp, true);
	    		var titleLit = titleRes.QueryInterface(Components.interfaces.nsIRDFLiteral);				      
					this.debug('removing subdomain: ' + titleLit.Value);			
					sitecontrols.SCSVC.removeControlledSite(titleLit.Value);  			
					container.RemoveElement(child , false);
				}
			}
			catch (ex){				
				this.debug('site is not a container');	
			}							
			
			/*===================================================
				Remove the site from the datastore
			===================================================*/														
      var titleProp = sitecontrols.RDF.GetResource(sitecontrols.SC_NS+'title');
      var titleRes = sitecontrols.SCDS.GetTarget(site, titleProp, true);
	    var titleLit = titleRes.QueryInterface(Components.interfaces.nsIRDFLiteral);				      
			this.debug('removing site: ' + titleLit.Value);			
			sitecontrols.SCSVC.removeControlledSite(titleLit.Value);   									
	
	},
		
	ensureExplicitSiteControl : function(url) {
		var sc = sitecontrols.SCSVC;
		var site = sc.getResourceForURI(url);
		if (site.Value != sitecontrols.SC_LOCAL)
		{
			var host = sitecontrols.getHostStringFromURL(url);
			var pattern = sitecontrols.SCSVC.getControlledSite(host);
			if ((pattern != null) || (host && (host != "") && (host != pattern))) {
				sitecontrols.SCSVC.addControlledSite(host);
				site = sitecontrols.SCSVC.getResourceForURI(host);				
			}
		}
		return site;
	},
	
	isSiteAllowed : function(url) {
		var sc = sitecontrols.SCSVC;
		var site = sc.getResourceForURI(url);
		if (site.Value != sitecontrols.SC_LOCAL)
		{
			var host = sitecontrols.getHostStringFromURL(url);
			var pattern = sitecontrols.SCSVC.getControlledSite(host);
			if ((pattern != null) || (host && (host != "") && (host != pattern))) {
				return true;
			}
		}
		return false;		
	},
		
	show_rdf_ds : function(ds) {
	
	//this.debug('\n ============= show_rdf_ds START =================\n');
	
  var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].

                   getService(Components.interfaces.nsIRDFService);
  
  var t="";

  var all_res=ds.GetAllResources();

  for(var r=0; all_res.hasMoreElements(); r++)

  {

    //if(t.length>5000) break;  // comment out for unlimited output

    var res=all_res.getNext();

    // res is a resource

    if (res instanceof Components.interfaces.nsIRDFResource)

    {

      var tr=r + " R: "+res.Value+"\n";

      var ps= ds.ArcLabelsOut(res);

      while (ps.hasMoreElements())

      {

        var predicate = ps.getNext();

        // predicate is a resource

        if (predicate instanceof Components.interfaces.nsIRDFResource)

        {

          tr+="  -R:  "+predicate.Value+"\n";

          var ts= ds.GetTargets(res, predicate, true);

          while (ts.hasMoreElements())

          {

            var target = ts.getNext();

            // target is either a resource, a literal or a typed-literal

            if (target instanceof Components.interfaces.nsIRDFResource)

              tr+="   >R: "+target.Value+"\n";

            else

            if (target instanceof Components.interfaces.nsIRDFLiteral)

              tr+="    >L: "+target.Value+"\n";

            else

            if (target instanceof Components.interfaces.nsIRDFBlob)

              tr+="    >BLOB length:"+target.length+"\n";

            else

            if (target instanceof Components.interfaces.nsIRDFInt)

              tr+="    >INT:"+target.Value+"\n";

            else

            if (target instanceof Components.interfaces.nsIRDFDate)

              tr+="    >DATE: "+target.Value+"\n";

            else

            if (target instanceof Components.interfaces.nsIRDFNode)

              tr+="    >Node \n";

            else

              tr+="    >Unknown\n";

          }

        } // end predicate-res

     } // end ps

     t+=tr+"\n";

    } else // should never happen

    if (res instanceof Components.interfaces.nsIRDFLiteral)

    {

      t+=r + "L: "+res.Value+"\n";

    } else

      t+=r + "?: "+"\n";

  }

	this.debug(t);    
	
	this.debug('\n ============= show_rdf_ds END =================\n');

},

	// It's *probably* okay to get rid of this entirely... but first make sure it's not
	// being called from anywhere else
	updateSecurityLevel : function(currentURI) {
		this.SCSVC.updateSiteControl(this.getHostStringFromURL(currentURI), 'securityLevel', 'Custom');
		this.debug('*** set securityLevel to CUSTOM');
	},

	setSecurityLevel : function(site, level, reload) {
		this.debug('setSecurityLevel(...,'+level+')');
					
		var resourceToCopy = null;
		switch (level) {
		case 'Low':
		case 'low': // I Trust
			resourceToCopy = sitecontrols.RDF.GetResource(this.SC_VERIFIED_DEFAULT);
			this.SCSVC.updateSiteControlResource(site, 'securityLevel', 'Low');
			break;
		case 'Medium':
		case 'medium': // I'm not sure
			resourceToCopy = sitecontrols.RDF.GetResource(this.SC_NOT_VERIFIED_DEFAULT);
			this.SCSVC.updateSiteControlResource(site, 'securityLevel', 'Medium');
			break;
		case 'High':
		case 'high': // I don't trust
			resourceToCopy = sitecontrols.RDF.GetResource(this.SC_WARNING_DEFAULT);
			this.SCSVC.updateSiteControlResource(site, 'securityLevel', 'High');
			break;
		default:
			this.debug('WARNING: unrecognized security level ['+level+']');
			return;
		}
		var propertiesToCopy = [ 'displayEngine', 'allowPopups', 'requestedPopupsInTab',
		                         'allowImages', 'imagesFromOrigOnly', 'enableActiveX',
		                         'enableJava', 'enableJavaScript', 'jsMoveResize',
		                         'jsRaiseLower', 'jsContextMenu', 'jsHideStatusBar',
		                         'jsStatusBarText', 'jsChangeImages', 'allowCookies',
		                         'cookiesFromOrigOnly', 'allowRunPrograms', 'askBeforeRunning' ];
		this.debug(' about to copy properties...');
		for (var i=0;i!=propertiesToCopy.length;i++){
			var prop = propertiesToCopy[i];
			try {										
				var value = this.SCSVC.readSiteControlResource(resourceToCopy, prop);				
				this.SCSVC.updateSiteControlResource(site, prop, value);
			} catch (ex) {							
				this.debug('WARNING: error copying property "'+prop+'"');
			}
		}
		
		if (reload == null || reload){	
			this.debug(' ...reloading the browser.');
			BrowserReload();
			// If the current display engine is Trident then notify
			var displayEngine = this.SCSVC.readSiteControlResource(site, 'displayEngine');			
			if (displayEngine.value == 'Trident') this.notifyUser('switch_to_ie');
		}
				
		this.debug(' ...END setSecurityLevel.');
	},


	getHostStringFromURL : function(url) {		
		var dbg = false;
		var host = url;
		if (dbg) this.debug('Parsing URL: '+url);

		// if this is a local file
		if(url.indexOf("file://") == 0) {
			return this.SC_LOCAL;
		}

		//Merc - TO
		//BLT 202789
		//strip off wyciwyg://0/
		var wyciwygStr = "wyciwyg://";
		if(url.indexOf(wyciwygStr) == 0) {
			host = url.substring(wyciwygStr.length+2);
		}

		if (host.indexOf('://') > -1) {
			host = host.substring(host.indexOf('://')+3);
			if (dbg) this.debug('Stripped proto: '+host);
		}
		
		var postHostSlash = host.indexOf('/');
		if (postHostSlash > -1) {
			host = host.substring(0, postHostSlash);
			if (dbg) this.debug('Stripped path: '+host);
		}
		var userInfo = host.indexOf('@');
		if (userInfo > -1) {
			host = host.substring(userInfo+1);
			if (dbg) this.debug('Stripped user: '+host);
		}
		var port = host.indexOf(':');
		if (port > -1) {
			host = host.substring(0, port);
			if (dbg) this.debug('Stripped port: '+host);
		}
		return host;
	},


	getStrippedHostFromURL : function(url) {
		var host = this.getHostStringFromURL(url);
		return this.stripWWW(host);
	},


	getDomainFromURL : function(url) {
		var host = this.getHostStringFromURL(url);
		return this.getDomainFromHost(host);
	},


	getDomainFromHost : function(host) {
		var matches = this.getSiteStringsFromHost(host);
		return matches[matches.length-1];
	},


	getSiteStringsFromHost : function(host) {
		var matches = [];
		matches[matches.length] = host;
		var str = host;
		while ((str.indexOf('.') > -1) && (str.substring(str.indexOf('.')+1).indexOf('.') > -1)) {
			// There are at least two periods '.' in str
			str = str.substring(str.indexOf('.')+1);
			matches[matches.length] = str;
		}
		//for (i = 0; i < matches.length; i++) this.debug('match: '+matches[i]);
		return matches;
	},


	getSiteStringsFromURL : function(url) {
		var host = this.getHostStringFromURL(url);
		return this.getSiteStringsFromHost(host);
	},


	getControlledSiteFromHost : function(host) {
		return this.SCSVC.getControlledSite(host);
	},


	getControlledSiteFromURL : function(url) {
		var host = this.getHostStringFromURL(url);
		return this.getControlledSiteFromHost(host);
	},


	stripWWW : function(host) {
		if (host.substring(0,4)=='www.')
			return host.substring(4);
		else
			return host;
	},


	debug : function(msg) {
		if (this.DEBUG)
			dump('sitecontrols.js: '+msg+'\n');
	},


	dumpRDF : function() {
		var resources = this.SCDS.GetAllResources();
		while (resources.hasMoreElements()) {
			var res = resources.getNext();
			res.QueryInterface(this.kRDFRSCIID);
			this.debug('resource: '+res.Value);
			var labels = this.SCDS.ArcLabelsOut(res);
			while (labels.hasMoreElements()) {
				var label = labels.getNext();
				if (label instanceof this.kRDFRSCIID) {
					var dbg = ' * '+label.Value;
					var target = this.SCDS.GetTarget(res, label, true);
					if (target instanceof this.kRDFRSCIID) {
						dbg += ' => '+target.Value;
					} else if (target instanceof this.kRDFLITIID) {
						dbg += ' => '+target.Value;
					} else {
						try {
							dbg += ' => '+target.Value;
						} catch (ex) { }
					}
					this.debug(dbg);
				}
			}
		}
	}
};


	sitecontrols.initServices();
}



/***** Site Controls RDF Filter Wrapper *****/

// This is a wrapper for the rdf:sitecontrols datasource so that
// we can implement the filtering behaviour in the tree

const NS_RDF_NO_VALUE           = 0xa0002;
const NS_RDF_ASSERTION_REJECTED = 0xa0003;

const SC_TITLE = sitecontrols.RDF.GetResource(sitecontrols.SC_NS + "title");
const SC_DISPLAY = sitecontrols.RDF.GetResource(sitecontrols.SC_NS + "display");
const SC_FILTER_INCLUDE = sitecontrols.RDF.GetResource(sitecontrols.SC_NS + "filterinclude");

function SiteControlsFilterDataSource()
{
	dump("sitecontrols.js : SiteControlsFilterDataSource\t\t");
	this.mInner = sitecontrols.RDF.GetDataSource("rdf:sitecontrols");
	this.mInner.AddObserver(this);
	this.mObservers = new Array();
	this.mFilter = null;

}

SiteControlsFilterDataSource.prototype = {

	SetFilter : function(str) {
		if (!str || (str == ''))
			this.mFilter = null;
		else
			this.mFilter = str;
	},

	/* nsIRDFDataSource */
	URI: "rdf:sitecontrols-filtered",

	GetSource: function(pred, obj, tv) {
		
		return this.mInner.GetSource(pred, obj, tv);
	},

	GetSources: function(pred, obj, tv) {
		
		return this.mInner.GetSources(pred, obj, tv);
	},

	GetTarget: function(subj, pred, tv) {
		
		// All resources other than TITLEs are handled normally
		var target = this.mInner.GetTarget(subj, pred, tv);
		if (pred != SC_TITLE) return target;

		var name = this.mInner.GetTarget(subj, NC_NAME, true)
		               .QueryInterface(Components.interfaces.nsIRDFLiteral)
		               .Value;

		// Omit the 'special' site controls
		if (name == 'Verified Default' ||
		    name == 'Not Verified Default' ||
		    name == 'Warning Default' ||
		    name == 'Local Files')
		{
			return null;
		}

   		if (this.mFilter) {
			// Only return the value if it matches the filter
			if (name.indexOf(this.mFilter) == -1)
				return null;
			else
				return sitecontrols.RDF.GetLiteral(name);
		} else {
			return target;
		}
	},

	GetTargets: function(subj, pred, tv) {
		
		// All resources other than TITLEs are handled normally
		var targets = this.mInner.GetTargets(subj, pred, tv);
		if (pred != SC_TITLE) return targets;

		// Create a wrapper enumerator that will skip any
		// items that don't match the filter, etc.
		var enumerator = {
			mInner : null,
			mFilter : null,
			mTotal : 0,
			mNext : 1,
			init : function(initEnum) {
				while (initEnum.hasMoreElements()) {
					node = initEnum.getNext();
					lit = node.QueryInterface(Components.interfaces.nsIRDFLiteral);
					if (lit.Value == 'Verified Default' ||
					    lit.Value == 'Not Verified Default' ||
					    lit.Value == 'Warning Default' ||
					    lit.Value == 'Local Files')
					{
						continue;
					}
					if (!this.mFilter || lit.Value.indexOf(this.mFilter) != -1)
						this.mTotal++;
				}
			},
			hasMoreElements : function() {
				return (this.mNext <= this.mTotal);
			},
			getNext : function() {
				while (this.mInner.hasMoreElements()) {
					node = this.mInner.getNext();
					if (!node) return null;
					lit = node.QueryInterface(Components.interfaces.nsIRDFLiteral);
					if (lit.Value == 'Verified Default' ||
					    lit.Value == 'Not Verified Default' ||
					    lit.Value == 'Warning Default' ||
					    lit.Value == 'Local Files')
					{
						continue;
					}
					if (!this.mFilter || lit.Value.indexOf(this.mFilter) != -1) {
						this.mNext++;
						return lit;
					}
				}
				return null;
			}
		};
		enumerator.mInner = targets;
		enumerator.mFilter = this.mFilter;
		enumerator.init(this.mInner.GetTargets(subj, pred, tv));
		return enumerator;
	},

	Assert: function(subj, pred, obj, tv)        { throw NS_RDF_ASSERTION_REJECTED; },
	Unassert: function(subj, pred, obj, tv)      { throw NS_RDF_ASSERTION_REJECTED; },
	Change: function(subj, pred, oldobj, newobj) { throw NS_RDF_ASSERTION_REJECTED; },
	Move: function(oldsubj, newsubj, pred, obj)  { throw NS_RDF_ASSERTION_REJECTED; },

	HasAssertion: function(subj, pred, obj, tv) {
		// All resources other than TITLEs are handled normally
		var hasAssert = this.mInner.HasAssertion(subj, pred, obj, tv);
		if (pred != SC_TITLE) return hasAssert;

		var lit = obj.QueryInterface(Components.interfaces.nsIRDFLiteral);
		if (lit.Value == 'Verified Default' ||
		    lit.Value == 'Not Verified Default' ||
		    lit.Value == 'Warning Default' ||
		    lit.Value == 'Local Files')
		{
			return null;
		}

		if (this.mFilter && lit.Value.indexOf(this.mFilter) == -1)
			return null;
		else
			return hasAssert;
	},

	AddObserver: function(aObserver) {
		this.mObservers.push(aObserver);
	},

	RemoveObserver: function(aObserver) {
		for (var i = 0; i < this.mObservers.length; ++i) {
			if (aObserver == this.mObservers[i]) {
				this.mObservers.splice(i, 1);
				break;
			}
		}
	},

	ArcLabelsIn: function(obj) {
		return this.mInner.ArcLabelsIn(obj);
	},

	ArcLabelsOut: function(subj) {
		return this.mInner.ArcLabelsOut(subj);
	},

	GetAllResources: function() {     	
		return this.mInner.GetAllResources();
	},

	hasArcIn: function(obj, pred) {
		return this.mInner.hasArcIn(obj, pred);
	},

	hasArcOut: function(subj, pred) {
		return this.mInner.hasArcOut(subj, pred);
	},

	/* nsIRDFObserver */
	onAssert: function(ds, subj, pred, obj) {
		for (var obs in this.mObservers)
			obs.onAssert(this, subj, pred, obj);
	},

	onUnassert: function(ds, subj, pred, obj) {
		for (var obs in this.mObservers)
			obs.onUnassert(this, subj, pred, obj);
	},

	onChange: function(ds, subj, pred, oldobj, newobj) {
		for (var obs in this.mObservers)
			obs.onChange(ds, subj, pred, oldobj, newobj);
	},

   	onMove: function(ds, oldsubj, newsubj, pred, obj) {
		for (var obs in this.mObservers)
			obs.onMove(ds, oldsubj, newsubj, pred, obj);
	}
};



