var installer = {
  // component class IDs
	kcidInstaller : '@netscape.com/browser/antispyware-install;1',

  // list of possible states that the window can be in
  stateQuery : 0,
  stateInstalling : 10,
  stateUpdating : 15,
  stateError : 20,
  stateDone : 30,
  stateDoneReboot : 35,
  stateCannotReboot : 40,
  
  // indicates the current display state
  currentState : 0,
  progressState : 0,
  
  // flags whether we are in our async loop
  bAsyncUpdate : false,
  
  // Installer component
  installer : null,
  
  // flag if we clicked cancel
  bCancelled : false,

  // init() is called when the installer window is initially loaded.
  // It sets up initial states, etc.
  init : function() {
    this.currentState = this.stateQuery;
  },
  
  // updateDisplay() - update the display of the installer dialog based
  // on the current state as defined in currentState.
  updateDisplay : function() {
    switch (this.currentState) {
      case this.stateQuery:
        this.showDeckLayer('installDeck', 'queryInstall');
        window.sizeToContent();
        break;
        
      case this.stateInstalling:
        this.showDeckLayer('installDeck', 'progressInstall');
        this.showDeckLayer('progressDeck', 'progressInstall');
        window.sizeToContent();
        break;
       
      case this.stateUpdating:
        this.showDeckLayer('progressDeck', 'progressUpdate');
        break;
        
      case this.stateError:
        this.showDeckLayer('installDeck', 'errorInstall');
        break;
        
      case this.stateDone:
        this.showDeckLayer('installDeck', 'okInstall');
        break;

      case this.stateDoneReboot:
        this.showDeckLayer('installDeck', 'okInstallReboot');
        break;
        
      case this.stateCannotReboot:
        this.showDeckLayer('installDeck', 'errorReboot');
        break;
    }
  },
  
  showDeckLayer : function(deckId, layerId) {
    var deck = document.getElementById(deckId);
    for (var i = 0; i < deck.childNodes.length; i++) {
      if (deck.childNodes[i].id == layerId) {
        deck.selectedIndex = i;
        return;
      }
    }
  },

  actionInstall : function() {
    this.performInstall();
  },
  
  actionDontInstall : function() {
    this.setReturnValue(false);
    window.close();
  },
  
  actionCancel : function() {
    this.installer.cancel();
    this.setReturnValue(false);
    this.bCancelled = true;
  },
  
  actionErrorOK : function() {
    this.setReturnValue(false);
    window.close();
  },
  
  actionDone : function() {
    this.setReturnValue(true);
    window.close();
  },
  
  actionReboot : function() {
    this.setReturnValue(false);
    if (!this.installer.reboot()) {
      // unable to initiate OS reboot
      this.currentState = this.stateCannotReboot;
      this.updateDisplay();
                       
    } else {
      window.close();
    }
  },
  
  setReturnValue : function(value) {
    if ( ("arguments" in window) && 
         (window.arguments[0] instanceof 
            Components.interfaces.nsIDialogParamBlock) ) {
      window.arguments[0].SetInt(0, value);
    }
  },
  
  performInstall : function() {
 		this.installer = Components.classes[this.kcidInstaller].createInstance(Components.interfaces.nsISpyWatchInstall);
 		
 		// check if the component is already registered - if not install it
 		dump('Perform spyware component install\n');
    this.currentState = this.stateInstalling;
    this.updateDisplay();
 		this.installer.install();
    this.bAsyncUpdate = true;
    this.updateDisplayAsync();
  },
  
  updateDisplayAsync : function() {
    var bIsInstalled = false;
    var progbar = document.getElementById('spywatch.install.progress');
    progbar.value = this.installer.updatePercent;
    dump('Percent complete: ' + this.installer.updatePercent + '\n');
    
    if (this.installer.isDone) {
      switch (this.currentState) {
        case this.stateInstalling:
          dump('Installer finished stateInstalling\n');
          this.currentState = this.stateUpdating;
          this.updateDisplay();
          this.installer.update();
          break;
          
        case this.stateUpdating:
          dump('Installer finished stateUpdating\n');
          this.bAsyncUpdate = false;
          
          if (this.bCancelled) {
            // user cancelled - just exit
            window.close();
          }
          else if (this.installer.installFailed) {
            this.currentState = this.stateError;
          } 
          else if (this.installer.mustReboot) {
            bIsInstalled = true;
            this.currentState = this.stateDoneReboot;
          }
          else {
            bIsInstalled = true;
            this.currentState = this.stateDone;
          }
          break;
      }
      
      if (bIsInstalled) {
        var svcPref = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefBranch);
        svcPref.setBoolPref('spywatch.isInstalled', true);
      }
    }
    
    this.updateDisplay();
    if (this.bAsyncUpdate) {
      setTimeout("installer.updateDisplayAsync()", 500);      
    }
  }
}